Package: tilingArray
Version: 1.88.0
Title: Transcript mapping with high-density oligonucleotide tiling
        arrays
Author: Wolfgang Huber, Zhenyu Xu, Joern Toedling with contributions from Matt Ritchie
Maintainer: Zhenyu Xu <zxu@embl.de>
Depends: R (>= 2.11.0), Biobase, methods, pixmap
Imports: strucchange, affy, vsn, genefilter, RColorBrewer, grid, stats4
Suggests:
Description: The package provides functionality that can be
	useful for the analysis of high-density tiling microarray data (such
	as from Affymetrix genechips) for measuring transcript abundance and
	architecture. The main functionalities of the package are: 1. the class
	'segmentation' for representing partitionings of a linear series of
	data; 2. the function 'segment' for fitting piecewise constant models
	using a dynamic programming algorithm that is both fast and exact; 3.
	the function 'confint' for calculating confidence intervals using the
	strucchange package; 4. the function 'plotAlongChrom' for generating
	pretty plots; 5. the function 'normalizeByReference' for probe-sequence
	dependent response adjustment from a (set of) reference
	hybridizations.
Reference: Huber W, Toedling J, Steinmetz, L. Transcript mapping with
        high-density oligonucleotide tiling arrays. Bioinformatics 22,
        1963-1970 (2006).
License: Artistic-2.0
Collate: AllClasses.R AllGenerics.R normalizeByReference.R posMin.R
        otherStrand.R qcPlots.R comparisonPlot.R plotAlongChromLegend.R
        readCel2eSet.R confint.segmentation.R plotAlongChrom.R
        sampleStep.R costMatrix.R plotPenLL.R segChrom.R findsegments.R
        grid.image.R raster.image.R plotSegmentationDots.R
        plotSegmentationHeatmap.R PMindex.R methods-segmentation.R
        zzz.R
LazyLoad: Yes
biocViews: Microarray, OneChannel, Preprocessing, Visualization
git_url: https://git.bioconductor.org/packages/tilingArray
git_branch: RELEASE_3_22
git_last_commit: 14b8616
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: yes
Packaged: 2025-10-30 06:57:20 UTC; biocbuild

findSegments = function(x, maxcp, maxk, verbose=TRUE)
{
  if(is.matrix(x)) {
    n = nrow(x)
  } else {
    n = length(x)
  }
  maxcp   = as.integer(maxcp)
  maxk    = as.integer(maxk)
  verbose = as.integer(verbose)
  if(maxcp>n)
    stop(sprintf("maxcp=%d must not be larger than nrow(x)=%d", maxcp, n))
  if(maxk>n)
    stop(sprintf("maxk=%d must not be larger than length(x)=%d", maxk, n))
  if(verbose)
    cat(sprintf("findsegments: Calculation of cost matrix Gmean, n=%d, maxk=%d.\n",
                n, as.integer(maxk)))
  G = costMatrix(x, maxk)
  if (verbose) cat("Segmentation by dynamic programming.\n")
  res = .Call("findsegments", G, maxcp, verbose, PACKAGE="tilingArray")

  res$dat         <- x
  res$residuals   <- NULL
  res$chosenSegNo <- NULL
  res$confInt     <- NULL
  res$call        <- match.call()

  class(res) = c("segmentation", class(res))
  return(res)
  
}## findSegments

##-----------------------------------------------------------------------
## This function calculates the cost matrix for a homoscedastic model
## G[k,i] is the sum of squared residuals of a segment from i to (i+k-1)
##-----------------------------------------------------------------------
costMatrix = function(x, maxk) {
  if(!is.numeric(x)||!(is.vector(x)||is.matrix(x)))
    stop("'x' must be a numeric vector or matrix.")

  if(is.vector(x))  {
    r = x
    q = x*x
    d = 1
  } else {
    r = rowSums(x)
    q = rowSums(x*x)
    d = ncol(x)
  }
  n = length(r)
  
  if(!is.numeric(maxk)||(length(maxk)!=1)||(maxk<=1)||(maxk>n))
    stop(sprintf("'maxk' must be a single number between 2 and the number of rows of 'x': %d.", n))

  ## see inst/doc/costMatrix.tex (.pdf) for explanation of the algebra
  cr = cumsum(r)
  cq = cumsum(q)
  
  G = matrix(as.numeric(NA), nrow=maxk, ncol=n)
  k = 1:maxk
  G[, 1] = cq[k] - cr[k]*cr[k]/(k*d)
  m = if(n==maxk) (maxk-1) else (maxk)
  for(k in seq_len(m)) {
    i   = 1:(n-k)
    j   = 2:(n-k+1)
    cqk = cq[i+k]-cq[i]
    crk = cr[i+k]-cr[i]
    G[k,j] = cqk - crk*crk/(k*d)
  }
  return(G)
}

normalizeByReference = function(x, reference, pm, background, refSig, nrStrata=10,
  cutoffQuantile=0.05, plotFileNames, verbose=FALSE) {

  ##--------------- process and check the input arguments ---------------------------

  ## process 'x'
  if(!is(x, "ExpressionSet"))
    stop("'x' must be an object of class 'ExpressionSet'")
  n = nrow(exprs(x))
  d = ncol(exprs(x))
  if(d<1)
    stop("There is nothing to normalize in 'x'.")

  ## process 'pm' and 'background'
  checkindex = function(v) {
    nm = deparse(substitute(v))
    if(any(is.na(v)))
      stop(sprintf("'%s' must not contain NA.", nm))
    if(is.logical(v)) {
      if(length(v)!=n)
        stop(sprintf("%d must be logical vector of length %d.", nm, n))
      v = which(v)
    } else {
      if(!(is.integer(v)&&(length(v)>1)&&(min(v)>=1)&&(max(v)<=n)))
        stop(sprintf("'%s' must be an integer vector with values between 1 and %d.", nm, n))
      if(any(duplicated(v)))
        stop(sprintf("'%s' must not contain duplicated indices.", nm))
    }
    return(v)
  }

  pm = checkindex(pm)
  background = checkindex(background)

  mtb = match(background, pm)
  if(any(is.na(mtb)))
    stop("'background' must be a subset of 'pm'.")
  
  ## process 'reference' and 'refSig'
  if(!xor(missing(refSig), missing(reference)))
    stop("Please specify either the argument 'refSig' or 'reference' (but not both, or none of them).")
  
  if(missing(refSig)) {
    if(!is(reference, "eSet"))
      stop("'reference' must be an object of class 'eSet'")
    if(n!=nrow(exprs(reference)))
      stop("'x' and 'reference' must have 'exprs' elements in their 'assayData' slot with the same number of rows.")
    refSig = rowMeans(log2(exprs(reference)[pm,,drop=FALSE]))
  } else {
    if(!(is.numeric(refSig)&&(length(refSig)==length(pm))))
      stop("'refSig' must be a numeric vector whose length is the same as that of 'pm'.")
  }

  ##--------------- now the number crucnching starts ---------------------------
  
  ## quantiles of the reference intensities, to group probes into
  ## strata for the background estimations
  quants    = quantile(refSig, probs=seq(0, 1, length=nrStrata+1))
  quants[1] = quants[1]-1

  ## reference signal for the background features
  refSigBg = refSig[mtb]

  ## strata is now a factor with 'nrStrata' levels and of same length as 'background'
  strata     = cut(refSigBg, quants)

  if(any(table(strata) < 5e3))
    warning("'some strata of background contain fewer than 5000 features, are you sure this is alright?")
  
  xbg = (quants[-1]+quants[-length(quants)])/2  ## midpoint between quantiles
  ybg = matrix(as.numeric(NA), nrow=nrStrata, ncol=d)
  bgfun  = vector(mode="list", length=d)

  ## interpolate  
  for(j in 1:d) {
    ybg[, j] = tapply(log(exprs(x)[background, j], 2), strata, genefilter::shorth, tie.action="min")
    bgfun[[j]] = approxfun(xbg, ybg[,j], rule=2)
  }

  ## diagnostic plot of bgfun:
  if(!missing(plotFileNames)) {
    if(length(plotFileNames)!=d)
      stop("Please supply as many elements of 'plotFileNames' as there are arrays in 'x'")
    rgx = range(refSigBg)
    px  = seq(rgx[1], rgx[2], length=120)
    for(j in 1:d) {
      pdf(file=plotFileNames[j], width=8, height=6)
      smoothScatter(refSigBg, log(exprs(x)[background, j],2),
            xlab = "Reference intensity",
            ylab = "Background intensity", nrpoints=0)
      lines(px, bgfun[[j]](px), col="darkred")
      dev.off()
    }
  }
  
  ## apply the background and the scaling
  if(verbose) cat("Applying background and scaling\n")
  xn = matrix(as.numeric(NA), nrow=length(pm), ncol=d)
  ttrefsig = 2^refSig
  for(j in 1:d)
    xn[, j] = (exprs(x)[pm, j] - 2^bgfun[[j]](refSig)) / ttrefsig

  ## call vsn2 if there are >= 2 arrays
  if(d>=2) {
    if(verbose) cat("Calling 'vsn::vsnMatrix' for between array normalization and variance stabilizing transformation.\n")
    yn = exprs(vsn::vsnMatrix(xn, lts.quantile=0.95,
                         subsample=min(as.integer(2e5), nrow(xn)),
                         verbose=verbose))
  } else {
    yn = xn
    warning("'x' has only one column, cannot do between array normalization and variance stabilizing transformation")
  }
  
  ## throw out data from probes that have too small refSig, they are likely to
  ## be dominated by noise / unspecific signal
  throwOut = (refSig < quantile(refSig, probs=cutoffQuantile))
  yn[throwOut, ] = NA

  exprmat = matrix(as.numeric(NA), nrow=n, ncol=d)
  exprmat[pm, ] = yn

  res = x
  exprs(res) = exprmat

  return(res)  
}

# plotting along chromosome (extra bar/s, gff optional, legend at bottom optional)
# thresh argument missing in plotAlongChrom (used for setting global ylim for heatmaps)
# also need ability to change the color scheme for panel and main heatmap
plotAlongChrom = function(segObj, y, probeAnno, gff,
                          isDirectHybe=FALSE, 
                          what = c("dots"), ## "heatmap"
                          chr, coord, highlight,  
                          colors, 
                          doLegend=FALSE,
                          featureExclude=c("chromosome", "nucleotide_match", "insertion"),
                          featureColorScheme=1, extras, 
                          rowNamesHeatmap, rowNamesExtras, ylab, ylabExtras, main,
                          colHeatmap=colorRamp(brewer.pal(9, "YlGnBu")),
                          colExtras=colorRamp(brewer.pal(9, "Reds")), 
                          sepPlots=FALSE, reOrder=TRUE,...) {

  ## set up the viewports of the plot layout.
  VP = c("title"=0.4, "expr+"=5, "gff+"=1, "coord"=1, "gff-"=1, "expr-"=5, "legend"=0.4)

  if(sepPlots) { # matrix
     if(!missing(y))
        n <- ncol(y)
     if(!missing(segObj)) { # S4
        if(is.environment(segObj)) {
          segmentationObjectName = paste(chr, "+", sep=".")
          if(segmentationObjectName %in% ls(segObj)) {
            s <- get(segmentationObjectName, segObj)
            n <- ncol(s@y)
          }
          else { # old style list
            dat = get(paste(chr, strand, "dat", sep="."), segObj)
            n <- ncol(dat$y)
          }
        }
     }
     if(reOrder)
       ordering = seq(n,1, by=-1)
     else
       ordering = seq(1:n)
     if(n<4) {
         exprw <- exprc <- NULL
         for(i in 1:n) {
           exprw <- c(exprw, paste("expr", i, "+", sep=""))
           exprc <- c(exprc, paste("expr", i, "-", sep=""))
           }
         VPnames <- c("title", exprw, "gff+", "coord", "gff-", exprc, "legend")
         VP = c(0.8, rep(5, n), 1, 1, 1, rep(5, n), 0.4)
         names(VP) <- VPnames
      } else{
          cat("More than 4 arrays, plotting averages.\n")
          sepPlots=FALSE
      }
  }

  if(!missing(extras)) {
     indgff <-  grep("gff\\+", names(VP))
     indlegend <-  grep("legend", names(VP)) 
     VP <- c(VP[1:(indgff-1)], "extras+"=1, VP[indgff:(indlegend-1)], "extras-"=1, VP[indlegend:length(VP)])
  }
  if(!doLegend)
     VP = VP[names(VP)!="legend"]
  if(missing(gff))
     VP = VP[!(names(VP)=="gff+" | names(VP)=="gff-")]
  defaultColors = c("+" = "#00441b", "-" = "#081d58", "duplicated" = "grey",
    "cp" = "#555555", "ci" = "#777777", "highlight" = "red", "threshold" = "grey")
  if(!missing(colors)) {
    mt = match(names(colors), names(defaultColors))
    if(any(is.na(mt)))
    stop(paste("Cannot use color specification for", names(colors)[is.na(mt)]))
    defaultColors[mt] = colors 
  }
  colors = defaultColors

  ## check that either y or segObj is present
  if(!missing(y)) {
    if(missing(probeAnno))
      stop("If 'y' is specified, 'probeAnno' must also be specified.")
    if(!missing(segObj))
      stop("If 'y' is specified, 'segObj' must not be specified.")
  } else {
    if(missing(segObj))
      stop("Please specify either 'y' or 'segObj'")
  }

  pushViewport(viewport(width=0.85, height=0.95)) ## plot margin
  pushViewport(viewport(layout=grid.layout(length(VP), 1, heights=VP)))
  for(i in 1:2) {
    strand = c("+", "-")[i]

    ## extract and treat  the data
    threshold = as.numeric(NA)

    ## Three mutually exclusive cases:
    ## 1.) y and probeAnno
    ## 2.) segObj is an environment and contains objects of S4 class "segmentation"
    ##    whose names are obtained by paste(chr, strand, sep=".")
    ## 3.) segObj is an environment and contains lists
    ##    whose names are obtained by paste(chr, strand, "dat", sep=".")
    ##
    if(!missing(y)) {
      ## case 1.
      stopifnot(is.matrix(y))
      index = get(paste(chr, strand, "index", sep="."), envir=probeAnno)
      sta   = get(paste(chr, strand, "start", sep="."), envir=probeAnno)
      end   = get(paste(chr, strand, "end",   sep="."), envir=probeAnno)
      if(!missing(extras))
        dat = list(x = (sta+end)/2,
                   y   = y[index,, drop=FALSE],
                   flag = get(paste(chr, strand, "unique", sep="."), envir=probeAnno),  
                   extras = extras[index,, drop=FALSE]) # extras not currently supported 
							# for case 2 or 3.
      else   
        dat = list(x = (sta+end)/2,
                   y = y[index,, drop=FALSE],
                   flag = get(paste(chr, strand, "unique", sep="."), envir=probeAnno))
      stopifnot(is.numeric(dat$flag))
      lengthChr = end[length(end)]
      
    } else {
      if(!is.environment(segObj))
        stop("'segObj' must be an environment.")
      
      segmentationObjectName = paste(chr, strand, sep=".")
      if(segmentationObjectName %in% ls(segObj)) {
        ## case 2: S4 class
        s = get(segmentationObjectName, segObj)
        if(!inherits(s, "segmentation"))
          stop(sprintf("'%s' must be of class'segmentation'.", segmentationObjectName))
        if(is.na(s@nrSegments))
          stop(sprintf("Slot 'nrSegments' of '%s' must not be NA.", segmentationObjectName))
        bp = s@breakpoints[[s@nrSegments]]
        dat = list(x=s@x, y=s@y, flag=s@flag, estimate = bp[, "estimate"])
        if("upper" %in% colnames(bp)) dat$upper = bp[, "upper"]
        if("lower" %in% colnames(bp)) dat$lower = bp[, "lower"]
        lengthChr <- max(s@x, na.rm=TRUE)

      } else {
        ## case 3: list 'dat' and other stuff
        dat = get(paste(chr, strand, "dat", sep="."), segObj)
        stopifnot(all(c("start", "end", "unique", "ss") %in% names(dat)))
        dat$x = (dat$start + dat$end)/2
        dat$flag = dat$unique
        lengthChr = dat$end[length(dat$end)]
        
        if("segScore" %in% ls(segObj)) {
          sgs = get("segScore", segObj)
          sgs = sgs[ sgs$chr==chr & sgs$strand==strand, c("start", "end") ]
        } else {
	  stop("This option is deprecated")
	  ##nrSegments = ...
          ##seg = get(paste(chr, strand, "seg", sep="."), segObj)
          ##th  = c(1, seg$th[nrSegments+1, 1:(nrSegments+1)])
          ##sgs = list(start  = dat$start[dat$ss][th[-length(th)]],
          ##           end    = dat$end[dat$ss][th[-1]]-1)
        }
        dat$estimate = (sgs$start[-1] + sgs$end[-length(sgs$end)]) / 2

        if("theThreshold" %in% ls(segObj))
          threshold = get("theThreshold", segObj)
      } 
    }
    ## At this point, no matter what the input to the function was,
    ##    we have the list 'dat' with elements
    ## x: x coordinate
    ## y: y coordinate
    ## flag
    ## extras (optional, for plotting an extra panel, such as p-values for each segment)
    ## estimate (optional)
    ## lower (optional)
    ## upper (optional)
    ## and possibly also a non-NA value for 'threshold'.

    ## if no region is specified, plot the whole chromosome
    if(missing(coord))
      coord = c(1, lengthChr)
    
    ## plot the data
    vpr=which(names(VP)==sprintf("expr%s", strand))
    switch(what,
      "dots" = {
      if(sepPlots) {
       ylimdata = quantile(as.vector(dat[["y"]][dat[["x"]]>=coord[1] & dat[["x"]]<=coord[2],]), c(0, 1), na.rm=TRUE)
       ylim=ylimdata 
       if(missing(ylab))
           ylab=colnames(dat$y)
       if(length(ylab)==1)
           ylab=rep(ylab, n)
       for(j in seq(1:n)) {
         datj <- dat
         datj$y <- dat$y[,ordering[j]]
         if(missing(ylab))
           ylab=colnames(dat$y)
         ## plot the data
         vpr=which(names(VP)==sprintf(paste("expr",j,"%s",sep=""), strand))
  
         plotSegmentationDots(datj, xlim=coord, ylim=ylim, ylab=ylab[ordering[j]], 
                         chr=chr, strand=ifelse(isDirectHybe, otherStrand(strand), strand),
                         vpr=vpr, colors=colors, sepPlots=sepPlots,...)
         } 
      } else
         plotSegmentationDots(dat, xlim=coord, ylab=ylab, 
                         chr=chr, strand=ifelse(isDirectHybe, otherStrand(strand), strand),
                         vpr=vpr, colors=colors, sepPlots=sepPlots,...)
 
       if(!missing(extras) & !missing(y)) {
             vpr2=which(names(VP)==sprintf("extras%s", strand))
             dat$y = dat$extras[,,drop=FALSE]
             plotSegmentationDots(dat, xlim=coord, chr=chr, 
                     strand=ifelse(isDirectHybe, otherStrand(strand),strand),
                     vpr=vpr2, colors=colors, colHeatmap=colExtras, 
                     ylab=ylabExtras, rowNames=rowNamesExtras,...)
        }
      },

      ## FIXME: Matt's spaghetti code needs cleanup
           
      "heatmap" = {
        plotSegmentationHeatmap(dat, xlim=coord, 
                                rowNames=rowNamesHeatmap,
                                chr=chr, 
                                strand=ifelse(isDirectHybe, otherStrand(strand), strand),
                                vpr=vpr, colors=colors, ylab=ylab,
                                colHeatmap=colHeatmap,...)
        if(!missing(extras) & !missing(y)) {
             vpr2=which(names(VP)==sprintf("extras%s", strand))
             dat$y = dat$extras[,,drop=FALSE]
             plotSegmentationHeatmap(dat, xlim=coord, chr=chr, 
                     strand=ifelse(isDirectHybe, otherStrand(strand),strand),
                     vpr=vpr2, colors=colors, colHeatmap=colExtras, 
                     ylab=ylabExtras, rowNames=rowNamesExtras,...)
        }
      },
           stop(sprintf("Invalid value '%s' for argument 'what'", what))
    ) ## switch
  
    ## plot the features
    if(!missing(gff))
      plotFeatures(gff=gff, chr=chr, xlim=coord, strand=strand, 
                   featureExclude=featureExclude, featureColorScheme=featureColorScheme,
                   vpr=which(names(VP)==sprintf("gff%s", strand)),...) 
  }

  ## chromosomal coordinates
  pushViewport(dataViewport(xData=coord, yscale=c(-0.4,0.8), extension=0, 
                            layout.pos.col=1, layout.pos.row=which(names(VP)=="coord")))
  grid.lines(coord, c(0,0), default.units = "native")
  tck = alongChromTicks(coord)
  grid.text(label=formatC(tck, format="d"), x = tck, y = 0.2, 
            just = c("centre", "bottom"), gp = gpar(cex=.6), default.units = "native")
  grid.segments(x0 = tck, x1 = tck, y0 = -0.17, y1 = 0.17,  default.units = "native")

  
  if(!missing(highlight)){
    ## this part was modified to draw arrows for transcripts rather than bars
    mt = (match(highlight$strand, c("-", "+"))-1.5)*2
    co = highlight$coord
    if(is.na(mt) || !is.numeric(co))
      stop("Invalid parameter 'highlight'.")
    strand.num <- ifelse(highlight$strand=="-",-1,1)
    grid.segments(x0=co, x1=co+(500*strand.num), y0=c(0.4,0.4)*mt, y1=c(0.4,0.4)*mt, default.units = "native", arrow=arrow(), gp=gpar(col="violetred4", lwd=4))
  }
  popViewport()

  ## title
  pushViewport(viewport(layout.pos.col=1, layout.pos.row=which(names(VP)=="title")))
  grid.text(label=paste("Chr ", chr, sep=""), x=0.5, y=1, just="centre", gp=gpar(cex=1))
  if(!missing(main))
    grid.text(label=main, x=0.05, y=1, just="centre", gp=gpar(cex=1))
  popViewport()

  ## legend
  if(doLegend)
    plotAlongChromLegend(which(names(VP)=="legend"),
         featureColorScheme=featureColorScheme, featureExclude=featureExclude)
  
  popViewport(2)
}

## ------------------------------------------------------------
## plot Features
## ------------------------------------------------------------

plotFeatures = function(gff, chr, xlim, strand, vpr, featureColorScheme=1, featureExclude=c("chromosome", "nucleotide_match", "insertion"), featureNoLabel=c("uORF", "CDS"),...) {

  pushViewport(dataViewport(xData=xlim, yscale=c(-1.2,1.2),  extension=0, clip="on",
    layout.pos.col=1, layout.pos.row=vpr))

  stopifnot(all(gff[,"start"] <= gff[, "end"]))
  sel = which(gff[, "chr"] == chr &
              gff[, "strand"]  == strand &
              gff[, "start"] <= xlim[2] &
              gff[, "end"]   >= xlim[1])

  stopifnot(length(strand)==1, strand %in% c("+", "-"))
  
  ## for label, use "gene" if available, otherwise "Name"
  geneName = gff[sel, "gene"]
  featName = gff[sel, "Name"]
  featName[!is.na(geneName)] = geneName[!is.na(geneName)]

  ## split by feature type (e.g. CDS, ncRNA)
  feature  = as.character(gff[sel, "feature"])
  featsp = split(seq(along=sel), feature)

  ## There are now five different cases, and we need to deal with them:
  ## - ignorable features, given by featureExclude
  ## - genes: a horizontal line + name
  ## - introns: a caret
  ## - CDS: a box + no name
  ## - all others: a colored box + name

  ## in this vector we save those features for which we want to have names
  whnames = integer(0)

  ## 1. drop the ignorable ones
  featsp = featsp[ ! (names(featsp) %in% featureExclude) ]
  
  ## 2. gene: just a horizontal line + name
  wh = ("gene" == names(featsp))
  if(any(wh)) {
    i = featsp[["gene"]]
    s = sel[i]
    grid.segments(x0 = gff$start[s], x1 = gff$end[s], y0 = 0, y1 = 0,
                  default.units = "native", gp = gpar(col="#a0a0a0"))
    whnames = i
    featsp = featsp[!wh]
  }

  ## 3.introns
  wh = ("intron" == names(featsp))
  if(any(wh)) {
    i = featsp[["intron"]]
    s = sel[i]
    mid = (gff$start[s]+gff$end[s])/2
    wid = (gff$end[s]-gff$start[s])/2 
    for(z in c(-1,1))
      grid.segments(x0 = mid,
                    x1 = mid+z*wid,
                    y0 = 1.20*c("+"=1, "-"=-1)[strand],  ## istrand is 1 or 2
                    y1 = 0.95*c("+"=1, "-"=-1)[strand],
                    default.units = "native",
                    gp = gpar(col="black"))
     featsp = featsp[!wh]
  } ## if
  
  ## 4. colors for boxes
  ## check that we know how deal with all features
  featCols = featureColors(featureColorScheme)

  whm = names(featsp) %in% rownames(featCols)
  if(!all(whm))
    warning("Don't know how to handle feature of type(s) '", paste(names(featsp)[!whm], collapse=", "), "' in gff.", sep="")

  sfeatsp  = featsp[rownames(featCols)]
  ll       = listLen(sfeatsp)
  
  if(any(ll>0)) {
    i  = unlist(sfeatsp)
    gp = gpar(col = rep(featCols$col,  ll),
                 fill = rep(featCols$fill, ll))
    s  = sel[i]
    grid.rect(x     = gff$start[s],
              y     = 0,
              width = gff$end[s]-gff$start[s],
              height= 2,
              default.units = "native",
              just  = c("left", "center"),
              gp    = gp)
    whnames = c(whnames, unlist(sfeatsp[!(names(sfeatsp) %in% featureNoLabel)]))
    ## additional potentially useful values for featureNoLabel: "binding_site", "TF_binding_site"
  }

  ## labels
  if( !all(tolower(featureNoLabel)=="all") && (length(whnames)>0)) {

    ## this is a bit of a hack to abbreviate the labels of "binding site" features:
    bindingRegexpr = "binding.?site.*$"
    isBindingSite = (regexpr(bindingRegexpr, featName[whnames]) > 0)
    if(any(isBindingSite)) {
      ## replace long labels
      featName[whnames] = gsub(bindingRegexpr, "bs", featName[whnames])
    }

    ## remove duplicated names that are not binding sites
    whnames = whnames[isBindingSite | !duplicated(featName[whnames])]

    txtcex = 0.6
    txtdy  = 0.7
    s      = sel[whnames]
    txtx   = (gff$start[s]+gff$end[s])/2
    txty   = numeric(length(s))
    ord    = order(txtx)
    whnames = whnames[ord]
    s      = s[ord]
    txtx   = txtx[ord]
    
    strw   = convertWidth(stringWidth(featName[whnames]), "native", valueOnly=TRUE)*txtcex
    rightB = txtx[1] + 0.5*strw[1]
    doText = rep(TRUE, length(whnames))

    # not used so far:
    # textstarts <-  txtx - 0.5*strw
    # textends   <-  txtx + 0.5*strw

    # adjust text labels to be still readable in feature-dense areas:
    if(length(whnames) >1) {
      for(k in 2:length(whnames)) {
        leftB = txtx[k] - 0.5*strw[k]
        if(leftB > rightB) { # all texts not overlapping next to each other?
          rightB = txtx[k] + 0.5*strw[k]
        } else { # any overlaps?
          if(!any(txty[k-(1:2)]==txtdy)) {#  2 previous labels not moved up?
            txty[k]= txtdy                #   then this one 
          } else {                        #  else try move down:
            if(!any(txty[k-(1:2)]== -txtdy)) { 
              txty[k]= -txtdy             #  if 2 previous ones weren't
            } else {
              doText[k] = FALSE           #  otherwise don't put the label
            }
          }
        } ##  else
      } ## for
    }
    
    grid.text(label = featName[whnames][doText],
              x = txtx[doText], y = txty[doText], gp=gpar(cex=txtcex), 
              default.units = "native")
  } ## if
  
  popViewport()

} ## plotFeatures

##------------------------------------------------------------
##
##------------------------------------------------------------
alongChromTicks = function(x){
  rx = range(x)
  lz = log((rx[2]-rx[1])/3, 10)
  fl = floor(lz)
  if( lz-fl > log(5, 10))
    fl = fl +  log(5, 10)
  tw = round(10^fl)
  i0 = ceiling(rx[1]/tw)
  i1 = floor(rx[2]/tw)
  seq(i0, i1)*tw
}

##------------------------------------------------------------
## featureColors
## note that features are drawn in the order in which they appear
## here, this can be used to let important features overdraw less
## important ones (e.g. tRNA is more specific than ncRNA)
## to test, say tilingArray:::plotAlongChromLegend()
##------------------------------------------------------------
featureColors = function(scheme=1){
  
  defaultColors = c(
    "chromosome"  = NA,
    "nucleotide_match" = "#e0e0e0",   ## light gray
    "pseudogene"  = "#e0e0e0",        ## light gray
    "uORF"        =   "#FED976" ,     ## orange
    "nc_primary_transcript" = "#a0a0a0",    ## grey
    "region" = "#cc66cc",           ## light red-violet	
    "repeat_family" = "#CC6666",    ## light red
    "repeat_region" = "#e31a1c",    ## bright red                    
    "transposable_element"  = "#f1b6da",    ## pink
    "transposable_element_gene"= "#f1b6da",
    "ARS"         = "#CC9966",    ## light brown
    "centromere"  = "#FFEDA0",    ## orange
    "telomere"    = "#FFEDA0",    ## orange
    "insertion"   = "#FFEDA0",    ## orange
    "CDS"         = "#addfff",    ## light blue
    "CDS_dubious" = "#e0f1f2",    ## lighter blue
    "ncRNA"       = "#a6d96a",    ## green 
    "tRNA"        = "#a6d96a",    ## green
    "snRNA"       = "#8C6BB1",    ## purple
    "rRNA"        = "#fdae61",    ## meat
    "snoRNA"      = "#7F5A58",    ## red brown
    "binding_site"    = "#C9C299", ## lemon chiffon
    "TF_binding_site" = "#C9C299" ## lemon chiffon
  )
  darkenborder = as.logical(c(rep(1,3),0,rep(1, 17),0,0))
  stopifnot(length(darkenborder)==length(defaultColors))
  
  fill = switch(scheme,
    default  = defaultColors,
    unicolor = ifelse(is.na(defaultColors), NA,  "#addfff"),  ## light blue
    stop("Sapperlot"))
  
  ## calculate hex string for a color that is a little bit darker than the
  ## hex string in the argument
  darken = function(x, factor=0.5) {
    wh = which(!is.na(x))

    hex = sapply(x[wh], substring, first=c(2,4,6), last=c(3,5,7))
    hex = apply(hex, 2, function(h) as.integer(factor*as.integer(paste("0x", h, sep=""))))

    res = rep(as.character(NA), length(x))
    res[wh] = apply(hex, 2, function(h) sprintf("#%02x%02x%02x", h[1], h[2], h[3]))
    return(res)
  }
  
  border = ifelse(darkenborder, darken(fill), fill)
  
  res = data.frame(fill=I(fill),
    col =I(border))
  rownames(res)=names(defaultColors) 
  return(res)
}

myWrite = function(x, nm, imgdir=NULL, pgm=FALSE) {
  if(pgm) {
    f1 = file.path(ifelse(is.null(imgdir), ".", imgdir), paste(nm, ".pgm", sep=""))
    write.pnm(x, file=f1, maxval=255)
  }
  else { ## convert from pgm to .jpg
    f1 = paste(tempfile(), ".pgm", sep="")
    f2 = file.path(ifelse(is.null(imgdir), ".", imgdir), paste(nm, ".jpg", sep=""))
    write.pnm(x, file=f1, maxval=255)
    cmd = paste("convert", f1, "-quality 100", f2, "&")
    system(cmd)
  }
}

myPixmap = function(z, rz=range(z), nr = 2560, nc = 2560) {
  nz  = (z-rz[1])/diff(rz)
  nz[is.na(nz)] = 0
  pixmapGrey(data=matrix(nz, nrow=nr, ncol=nc, byrow=TRUE))
}

matDensities <- function(X) {
        densXY <- function(Z) {
            zd <- density(Z, na.rm = TRUE)
            x <- zd$x
            y <- zd$y
            cbind(x, y)
        }
        out <- apply(X, 2, densXY)
        outx <- out[(1:(nrow(out)/2)), ]
        outy <- out[(((nrow(out)/2) + 1):nrow(out)), ]
        list(X = outx, Y = outy)
    }

qcPlots <- function(x, html=TRUE, plotdir=NULL, probeAnno, gff, 
                    chr=4, coord=c(230000,245000),
  		    nr = 2560, nc = 2560,
		    ylimchrom=c(5,16), nucleicAcid, pmindex, pgm=TRUE,
                    ext=".cel", ranks=FALSE, ...) {

    cat("Generating summary plots\n")
    narrays = nrow(pData(x))
    l2x  = log2(exprs(x))

    # boxplots of log2 intensities for PM probes
    cat("\tBoxplots of PM intensities")
    if(missing(nucleicAcid)) {
        nucleicAcid = NULL
      if(!is.null(x$nucleicAcid))
        nucleicAcid = x$nucleicAcid
      if(!is.null(x$NucleicAcid))
        nucleicAcid = x$NucleicAcid
      if(is.null(nucleicAcid))
        nucleicAcid = rep("RNA", narrays)    
      }
    if(missing(pmindex))
      pmindex = PMindex(probeAnno)
    l2xPM = l2x[pmindex,, drop=FALSE]
    z   = lapply(1:ncol(l2xPM), function(i) l2xPM[,i])
    colors = brewer.pal(9, "Set1")[as.integer(factor(nucleicAcid))]
    filename = file.path(ifelse(is.null(plotdir), ".", plotdir), "boxplot.png")
    png(filename, width=640, height=480)
    boxplot(z, col=colors, outline=FALSE, las=2, main = "Boxplots of PM intensities", ylab=expression(log[2](Intensity)))
    dev.off()
    rm(z)
    cat(" .... complete\n")
 
    # density plots of log2 intensities for PM probes
    cat("\tDensity plot of PM intensities")
    dens.x <- matDensities(l2xPM)
    filename = file.path(ifelse(is.null(plotdir), ".", plotdir), "densities.png")
    png(filename, width=640, height=480)
    matplot(dens.x$X, dens.x$Y, xlab=expression(log[2](Intensity)),
            ylab = "Density", col=colors,
            main = "Histogram of PM intensities",
            type = "l", lwd = 2, lty = 1)
    dev.off()
    rm(l2xPM)
    cat(" .... complete\n")

    # individual image, density and along chromosome dot plots (for region specified by user)
    cat("\nGenerating per array plots\n")
    rlx = range(l2x)
    lx  = (l2x-rlx[1])/diff(rlx)

    files <- NULL
    if(!is.null(x$file))
      files = x$file
    if(!is.null(x$File))
      files = x$File
    if(is.null(files))
      files = paste("array", seq(1:narrays), ext, sep="")

    for(i in 1:narrays) {
      cat(files[i], ":\nimageplot\t")
      filename = gsub(" ", "_", files[i])
      if(ranks)
      myWrite(myPixmap(rank(exprs(x)[,i])), sub(ext, ".rank", filename),
              imgdir=plotdir, pgm=pgm)
      if(!ranks)
      myWrite(myPixmap(lx[,i]),  sub(ext, ".log", filename),
              imgdir=plotdir, pgm=pgm)
      cat("density plot\t")     
      filename = file.path(ifelse(is.null(plotdir), ".", plotdir), 
                  paste(sub(ext, ".density", files[i]), ".png", sep=""))
      png(filename)
      if(narrays>1)
         matplot(dens.x$X[,i], dens.x$Y[,i], xlab=expression(log[2](Intensity)),            
                  ylab = "Density", col=colors[i], main = "Histogram of PM intensities", 
                  type = "l", lwd = 2, lty = 1)
      else
         matplot(dens.x$X, dens.x$Y, xlab=expression(log[2](Intensity)), ylab = "Density",
                  col=colors[i], main = "Histogram of PM intensities", type = "l", 
                  lwd = 2, lty = 1)
      dev.off()
      cat("along chromosome plot")     
      filename = file.path(ifelse(is.null(plotdir), ".", plotdir), paste(sub(ext, ".gencoord", files[i]), ".jpg", sep=""))
      jpeg(filename, width=960, height=480)
      plotAlongChrom(what="dots", chr=chr, coord=coord, y=matrix(l2x[,i], nc*nr,1),
           probeAnno=probeAnno, gff=gff, ylim=ylimchrom, ...)
      dev.off()
      cat(" .... complete\n")
      }
   rm(l2x)
   rm(lx)
   rm(rlx)
   gc()

   if(html) {
    cat("Creating html summary page")
     html <- list(NULL)

     html[[1]] = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n<html>\n<head>\n<title>Quality assessment of tiling array data</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n</head>"

     html[[2]] = "<h1>Quality assessment of tiling array data</h1>\n"
     html[[3]] = paste("<p>",date(),"</p>\n", sep="")
     html[[4]] = "<h2>Summary plots</h2>\n"
     html[[5]] = "<img src=\"boxplot.png\"><br>\n" 
     html[[6]] = "<img src=\"densities.png\"><br>\n"
     html[[7]] = "<h2>Individual plots</h2>\n"
     if(!is.null(x$SampleID) & !is.null(x$Strain)) 
          html[[8]] = "<table border=1>\n<tr bgcolor=\"lightgray\"><td><center><strong>Array</strong></center></td><td><center><strong>Filename</strong></center></td><td><strong>Strain</strong></td><td><strong>SampleID</strong></td><td><strong>Plots</strong></td></tr>\n"
     else
        html[[8]] = "<table border=1>\n<tr bgcolor=\"lightgray\"><td><center><strong>Array</strong></center></td><td><center><strong>Filename</strong></center></td><td><center><strong>Plots</strong></center></td></tr>\n"
     for(i in 1:narrays) {
        if(!is.null(x$SampleID) & !is.null(x$Strain)) 
          html[[i+8]] = paste("<tr><td><center>", i, "</center></td><td>", files[i], "</td><td>", x$Strain[i], "</td><td>", x$SampleID[i], "</td><td>
        <a href=\"", sub(ext, ".log", files[i]), ".jpg\">image</a>,", "<a href=\"", sub(ext, ".density", files[i]), ".png\">", "density</a>,", "<a href=\"", sub      (ext, ".gencoord", files[i]), ".jpg\">", "alongchrom</a></td></tr>\n", sep="")
          
        else 
          html[[i+8]] = paste("<tr><td><center>", i, "</center></td><td>", files[i], "</td><td> <a href=\"", sub(ext, ".log", files[i]), ".jpg\">image</a>,", "<a href=\"", sub(ext, ".density", files[i]), ".png\">", "density</a>,", "<a href=\"", sub      (ext, ".gencoord", files[i]), ".jpg\">", "alongchrom</a></td></tr>\n", sep="")
        }
     html[[i+9]] = "</table>\n</body>\n</html>"

     if(pgm)
       html = gsub("log.jpg", "log.pgm", html)
     if(ranks)
       html = gsub("log.", "rank.", html)
     filename = file.path(ifelse(is.null(plotdir), ".", plotdir), "qcsummary.htm")
     writeLines(unlist(html), con=filename)    
     cat(" .... complete\nOpen qcsummary.htm to view results.\n")
    }
}

segChrom = function(y, probeAnno, chr=1:17, strands=c("+", "-"),
		nrBasesPerSegment = 1500, maxk = 3000, step = 7, confint = FALSE,
		confintLevel = 0.95,   useLocks=TRUE, verbose=TRUE, savedir) {
	
  segObj = new.env(parent = baseenv())
  chrstrd = if((length(strands)==1) && is.na(strands)) {
    chr 
  } else { 
    paste(rep(chr, each=length(strands)), rep(strands, times=length(chr)), sep=".")
  }
	
  for(j in seq(along=chrstrd)) {
		
    skip=FALSE
    if(!missing(savedir)) {
      filename = file.path(savedir, paste(chrstrd[j], "rda", sep="."))
      if(useLocks)
	if(file.exists(filename)) {
	  skip=TRUE
	  if(verbose)
	    cat(sprintf("Skipping %s since %s already exists.\n", chrstrd[j], filename))
	} else {
          ## create lock file
	  con=file(filename, open="wt")
	  cat(system("uname -a; echo \"\n\"; date", intern=TRUE), file=con)
	  close(con)
        }
    } ## if(useLocks)
    
    if(!skip){
      if(verbose)
        cat(sprintf("Running 'segment' on chromosome %s", chrstrd[j]))
      
      ## construct dataframe 'df' with four columns as follows		
      df_colnames = c("start", "end", "index", "unique")
      pa_elements = paste(chrstrd[j], df_colnames, sep = ".")
      prbs = if(is(probeAnno, "probeAnno")) {
        lapply(pa_elements, function(w) probeAnno[w])
      } else if (is(probeAnno, "environment")) {
        mget(pa_elements, probeAnno)
      } else {
        stop(sprintf("Invalid class of argument 'probeAnno', is '%s', should be class 'probeAnno' or 'environment'.", class(probeAnno)))  
      } 	     

      prbs = do.call(data.frame, prbs)
      colnames(prbs) = df_colnames
			
      ## sort probes by chromosomal midpoint position:
      prbs$mid = (prbs$start + prbs$end)/2
      prbs = prbs[order(prbs$mid), ]
      
      ## remove missing (NA) values:
      numna = rowSums(is.na((if(is.matrix(y)) y else exprs(y))[prbs$index,,drop = FALSE]))
      stopifnot(all(numna %in% c(0, ncol(y))))
      prbs = prbs[numna == 0, ]
			
      ## subsample probes to overcome irregular probe spacing
      ##  esp. dense spacing in repetitive regions:
      sprb = prbs[sampleStep(prbs$mid, step = step), ]
      
      ## determine number of segments
      nsegs = as.integer(round(sprb$end[nrow(sprb)]/nrBasesPerSegment))
			
      ychr = (if(is.matrix(y)) y else exprs(y))[sprb$index, ,drop = FALSE]
	
      s = segment(ychr, maxseg = nsegs, maxk = maxk)
			
      s@x = sprb$mid
      s@flag = as.integer(sprb$unique)
			
      if(confint) {
        assign(chrstrd[j], confint(s, parm = nsegs, level = confintLevel), segObj)
      } else {
        s@nrSegments = nsegs
        assign(chrstrd[j], s, segObj)
      }
			
      if(!missing(savedir))
        save(s, file=filename)
			
      if(verbose)
        cat(" ... complete\n")
    } ## if(!skip)
  } ##  for j	
  return(segObj)
}

##
## methods associated with object of class "segmentation"
##   please see also file confint.segmentation.R
##
## (C) W. Huber 2005
##

##--------------------------------------------------
## Create a segmentation object
##--------------------------------------------------
segment = function(y, maxseg, maxk) {
  
  if(!is.matrix(y))
    y = matrix(y, ncol=1)
  n = nrow(y)
  maxseg = as.integer(maxseg)
  maxk  = as.integer(maxk)
  if(!((length(maxseg)==1) && !is.na(maxseg) && (maxseg<=n)))
    stop(sprintf("maxseg must be an integer of length 1 between 1 and nrow(y)=%d", n))
  if(!((length(maxk)==1) && !is.na(maxk) && (maxk<=n)))
    stop(sprintf("maxk must be an integer of length 1 between 1 and nrow(y)=%d", n))
  verbose = as.integer(0)
  
  G = costMatrix(y, maxk)
  fs = .Call("findsegments", G, maxseg, verbose, PACKAGE="tilingArray")

  bp = vector(mode="list", length=nrow(fs$th))
  for(i in seq(along=bp)) {
    stopifnot( fs$th[i, i] == n+1 )
    bp[[i]] = cbind(estimate=fs$th[i, 0:(i-1)])
  }
  
  new("segmentation",
    y = y,
    x = numeric(0), flag=integer(0),
    breakpoints = bp,
    logLik = fs$J,
    hasConfint = rep(FALSE, length(bp)))
} ## segment


##--------------------------------------------------
## Simple plot method
##--------------------------------------------------
setMethod("plot", "segmentation", 
  function(x, y, xlim, xlab="x", ylab="y", bpcol="black", bplty=1, pch=16, ...) {
    
  validObject(x)

  y = as.integer(y)
  if(!( (length(y)==1) && (!is.na(y)) && (y>=1) && (y<=length(x@breakpoints))))
    stop(sprintf("'y' must be an integer of length 1 with values between 1 and %d.",
                 length(x@breakpoints)))

  ply = x@y
  if(ncol(ply)>1) {
    note("slot 'y' has more than one column, calculating 'rowMeans'")
    ply = matrix(rowMeans(ply), ncol=1)
  }
  
  plx = if(length(x@x)==0) row(ply) else x@x

  ## extract the y-th set of breakpoints, and transform from index counts to actual
  ##   regressor values (plx)
  breakp = x@breakpoints[[y]]
  for(i in 1:ncol(breakp))
    breakp[,i] = plx[ breakp[,i] ]

  ## since y is the number of segments = 1 +  number of breakpoints
  stopifnot(nrow(breakp)==y-1)
  
  ## for handling large segmentation objects:
  if(!missing(xlim)) {
    stopifnot(is.numeric(xlim), length(xlim)==2)
    sel = (plx>=xlim[1]) & (plx<=xlim[2])
    ply = ply[sel, ]
    plx = plx[sel]
    breakp = breakp[ (breakp[, "estimate"]>=xlim[1]) & (breakp[, "estimate"]<=xlim[2]),, drop=FALSE ]
  }
  
  if(missing(bpcol))
    bpcol = rep(brewer.pal(9, "Set1"), ceiling(nrow(breakp)/9))[1:nrow(breakp)]
  
  plot.default(plx, ply, xlab=xlab, ylab=ylab, pch=pch, ...)
  abline(v=breakp[, "estimate"]-0.5, col=bpcol, lty=bplty) ## draw segment boundaries

  if (x@hasConfint[y]) { ##  confidence intervals
    for(j in 1:2) {
      at = breakp[, c("lower", "upper")[j]]
      isnotna = !is.na(at)
      isdup   = duplicated(at[isnotna])
      mtext(side=1, at=at[isnotna]-0.5+0.25*isdup, adj=0.5, text=c("(", ")")[j], line=-0.7, col=bpcol[isnotna])
    }
  }
}) # plot.segmentation
    
##--------------------------------------------------
## Show method
##--------------------------------------------------
setMethod("show", "segmentation", 
  function(object) {
    ans = c(
      sprintf("Object of class 'segmentation':\n"),
      sprintf("Data matrix: %d x %d\n", nrow(object@y), ncol(object@y)),
      sprintf("Change point estimates for number of segments S = 1:%d\n", length(object@breakpoints)))
    if(any(object@hasConfint)) {
      wh = which(object@hasConfint)
      ans = c(ans,
      sprintf("Confidence intervals for %d fits from S = %d to %d\n",
              length(wh), wh[1], wh[length(wh)]))
    }
    ans = c(ans, 
      sprintf("Selected S = %d\n", object@nrSegments))
    cat(ans, "\n", sep="")
  })

##--------------------------------------------------
## logLik
##--------------------------------------------------
setMethod("logLik", "segmentation", 
  function(object, penalty="none", ...) {
    ll   = object@logLik
    npar = 2*(1:length(ll))
    ndat = length(object@y)
    switch(penalty,
           none = ll,
           AIC = ll - npar,
           BIC = ll - log(ndat)*npar/2,
           stop(sprintf("Invalid value '%s' for argument 'penalty'.", penalty)))

  })

##------------------------------------------------------------
## legend
##------------------------------------------------------------
plotAlongChromLegend = function(vpr, nr=2, 
    featureColorScheme=1, featureExclude=c("chromosome", "nucleotide_match", "insertion"),
    mainLegend, cexLegend=0.35, cexMain=1){
  
  endVP = FALSE
  # when this function is called on its own 
  # set up a viewport
  if(missing(vpr)) { 
     endVP=TRUE      
     vpr = newVP(main=mainLegend, dataPanelHeight=1, cexMain=cexMain) # newVP sets up a new viewport
  }
  formatRow = function(featColsOneRow, row) {
    ## print(featColsOneRow)
    strWid   = convertWidth(stringWidth(rownames(featColsOneRow)), "npc", valueOnly=TRUE)
    n        = length(strWid)
    inbetWid = 0.2*min(strWid)
    totWid   = sum(strWid)+(n-1)*inbetWid
    x        = c(0, cumsum(strWid[-n])) + (0:(n-1))*inbetWid 
    y        = numeric(length(x))

    x      = x/totWid
    strWid = strWid/totWid
    grid.rect(x = x, width = strWid, 
              y = unit(row, "native"), height = unit(1, "native")- unit(1, "mm"), 
              just  = c("left", "center"), default.units="npc",
              gp    = do.call(gpar, featColsOneRow))
    
    grid.text(label = rownames(featColsOneRow),
              x = unit(x + strWid/2, "native"), y = unit(row, "native"),
              just  = c("center", "center"), gp=gpar(cex=cexLegend))
  } 

  featCols = featureColors(featureColorScheme)
  featCols = featCols[ !(rownames(featCols) %in% featureExclude), ]

  pushViewport(viewport(layout.pos.col=1, layout.pos.row=vpr, yscale=c(0.5, nr+0.5)))

  i = 1:nrow(featCols)
  for(r in 1:nr)
    formatRow(featCols[ceiling(i/nrow(featCols)*nr-1e-10)==r, ], row=nr-r+1)
  
  popViewport()

  if(endVP)
     popViewport(2)
}

# this function sets up a new viewport.  It is used by plotAlongChromLegend, 
# plotSegmentationHeatmap and plotSegmentationDots when they are called as 
# stand-alone functions (ie when vpr is not specified)

newVP <- function(main, cexMain=1, dataPanelHeight=1, vpHeight=0.7, titleOffSet=0) {
     if(!missing(main)) {
        vpr = c("title"=0.1, "data"=dataPanelHeight)
        pushViewport(viewport(width=0.85, height=vpHeight)) ## plot margin
        pushViewport(viewport(layout=grid.layout(length(vpr), 1, heights=vpr)))  
        pushViewport(viewport(layout.pos.col=1, layout.pos.row=which(names(vpr)=="title")))
        grid.text(label=main, x=0.5, y=1.1+titleOffSet, just="centre", gp=gpar(cex=cexMain))  
        popViewport()
        vpr = which(names(vpr)=="data")
     } else {
        vpr = c("data"=dataPanelHeight)
        pushViewport(viewport(width=0.85, height=vpHeight)) ## plot margin
        pushViewport(viewport(layout=grid.layout(length(vpr), 1, heights=vpr)))
     }
  vpr
  }

PMindex <- function(probeAnno) {
  isPM = logical(length(probeAnno$probeReverse$no_feature))
  for (j in probeAnno$probeReverse)
    isPM[as.character(j) != ""] = TRUE
  which(isPM)
}

BGindex <- function(probeAnno) {
  which(probeAnno$probeReverse$no_feature == "no" & probeAnno$probeDirect$no_feature == "no")
}

library(tilingArray)
options(error=recover)

for(f in dir("~/madman/Rpacks/tilingArray/R", pattern=".R$", full.names=TRUE))source(f)



set.seed(123)

## TEST 1: old versus new
if(!TRUE){
  lseg  = 12
  steps = seq(1, 4, length=20)
  steps = steps * sign(runif(length(steps))-0.5)
  dat   = cbind(rep(cumsum(steps), each=lseg) + rnorm(lseg*length(steps)))
  
  par(mfrow=c(2,1))
  
  seg1 = segment(dat, maxseg=30, maxk=nrow(dat))
  seg2 = confint(seg1, 20)
  
  plot(seg2, 20, pch=".")
  
  old1 = findSegments(dat, maxcp=30, maxk=nrow(dat))
  old2 = confint.segmentation(old1, 20)
  plot.segmentation(old2, 20, pch=".")
}

## TEST 2: dependence on number of replicates
lseg  = 20
steps = c(1, 1.05)
steps = steps * sign(runif(length(steps))-0.5)
nrrep = 30
res = matrix(NA, ncol=3, nrow=nrrep)
for(r in 1:nrrep) {
  dat   = sapply(1:r, function(i) rep(cumsum(steps), each=lseg) + rnorm(lseg*length(steps)))
  s = segment(dat, maxseg=5, maxk=nrow(dat))
  s = confint(s, 2)
  res[r, ] = s@breakpoints[[2]]
}
matplot(res, type="b", pch=16)

readCel2eSet = function(filename, adf, path=".", rotated=FALSE, ...) {

  if(!missing(filename)){
    if(!missing(adf))
      stop("If 'filename' is specified, please do not specify 'adf'")
    adf = new("AnnotatedDataFrame", data=data.frame(filename=I(filename)),
        varMetadata=data.frame(labelDescription=I(c(filename="Infered from 'filename' argument of readCel2eSet"))))
  } else {
    if(missing(adf))
      stop("Please specify either 'adf' or 'filename'")
    if(!("filename" %in% varLabels(adf)))
      stop("Please let 'adf' contain a column 'filename'")
    filename = adf$filename
  }

  
  a = affy::ReadAffy(filenames=filename, celfile.path=path, verbose=TRUE)
  ex = affy::intensity(a)
  ex = matrix(as.integer(ex), nrow=nrow(ex), ncol=ncol(ex))
  
  if(!rotated) {
    n = a@nrow
    if(a@ncol!=n)
      stop("Don't know how to deal with chips for which ncol != nrow")
    
    xy2i = function(coord) 1 + coord[,1] + n*coord[,2]
    i2xy = function(i)  cbind( x = (i-1) %% n, y = (i-1) %/% n )
    rotate = function(coord) {
      off = (n-1)/2
      rot = cbind(c(0,1), c(-1,0))
      off + (coord-off) %*% rot 
    }
    ex = ex[ xy2i(rotate(i2xy(1:(n*n)))),,drop=FALSE ]
  }

  new("ExpressionSet", exprs=ex, phenoData=adf, ...)
}

## A script for Marina Granovskaia to make Along-Chromosome Plots
## (C) W. Huber 2006
##
## Please specify the parameters in the following lines:

## Name of RNA and of DNA hybes.
## RNA must be a single file, for DNA multiple files can be separated by space
rna = "050208_mRNA30minx4_RH6.cel.gz"
## rna = "050209_mRNAx4_30min_re-hybe_RH6.cel.gz"
## rna = "050218_polyA-RNA_RH6_4x15min.cel.gz"

## rna = "05_04_27_2xpolyA_NAP3.cel.gz"

dna = "09_11_04_S96_genDNA_16hrs_45C_noDMSO.cel.gz  041119_S96genDNA_re-hybe.cel.gz   041120_S96genDNA_re-hybe.cel.gz"

## Set this to FALSE for newer scanner software, TRUE for older
## scanner software (that still rotated the .DAT files)
rotated = TRUE

## Directory Path to the CEL files
celpath =  "/ebi/research/huber/Projects/tilingArray/Celfiles"

## Which region should be plotted? (chromosome, start and end coordinates)
chr   = 10
start = 550000
end   = 580000
  
## ------------------------------------------------------------------------
## Now we are done with setting the parameters and can run the code
## ------------------------------------------------------------------------
library("tilingArray", verbose=FALSE)
library("davidTiling", verbose=FALSE)  ## Get these from Bioconductor

dna = strsplit(dna, " +")[[1]]
fnpretty = sub(".cel.*g*z*", "", rna, ignore.case=TRUE)

## Step 1: read the cel files
a = readCel2eSet(c(rna, dna), path=celpath, rotated=rotated)

## Step 2: DNA normalization
cat("Normalizing data")
data("probeAnno")
data("gff")

isRNA = a$filename %in% rna
isDNA = a$filename %in% dna
x = normalizeByReference(a[,isRNA], a[,isDNA], 
  pm=PMindex(probeAnno), background=BGindex(probeAnno),
  plotFileNames=sprintf("normalization-background-%s.pdf", fnpretty))

## Step 3: plot along chromosome
cat(".\nWriting the PDF file")
chr=as.integer(chr)
start=as.integer(start)
end=as.integer(end)
outfilename = sprintf("%s--chr%02d:%d-%d.pdf", fnpretty[1], chr, start, end)

pdf(file=outfilename, width=12, height=9)
trsf = function(x) { rg=range(x, na.rm=TRUE); log2(x-rg[1]+0.05*diff(rg)) }
plotAlongChrom(y=trsf(exprs(x)), probeAnno=probeAnno, gff=gff, chr=chr,
               coord=c(start, end), doLegend=TRUE, main=fnpretty[1])

dev.off()
cat(".\n\n")

## ==========================================================================
## (C) W. Huber 2005
## segmentation: a class to contain segmentation models (i.e. fits of
## piecewise constant functions)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
##--------------------------------------------------
## Validity method
##--------------------------------------------------
validSegmentation = function(object) {

  ## check that slots 'breakpoints', 'logLik', 'hasConfint' all have the same length
  if(!((length(object@breakpoints)==length(object@logLik)) &&
       (length(object@breakpoints)==length(object@hasConfint))))
    return(FALSE)
     
  ## check that nrow(y)==length(x)==length(flag)
  n = nrow(object@y)
  if(!(length(object@x)%in%c(0,n)))
    return(FALSE)
  if(!(length(object@flag)%in%c(0,n)))
    return(FALSE)

  if(!is.na(object@nrSegments))
    if(object@nrSegments<1 && object@nrSegments>length(object@breakpoints))
      return(FALSE)
  
  isGood = TRUE
  ## check the elements of the breakpoints slot (which is a list)
  for(i in seq(along=object@breakpoints)) {
    b = object@breakpoints[[i]]
    if(!((nrow(b)==i-1) && (ncol(b) %in% c(1,3)) &&
         ("estimate" %in% colnames(b)) && all(b[, "estimate"] <= n, na.rm=TRUE)))
      isGood = FALSE
  }
  return(isGood)
}

##--------------------------------------------------
## Definition
##--------------------------------------------------
setClass("segmentation",
   representation(
      y = "matrix",
      x = "numeric",
      flag = "integer",
      breakpoints = "list",
      logLik = "numeric",
      hasConfint = "logical",
      nrSegments = "integer"
   ),
   prototype = list(
      y = matrix(0, nrow=0, ncol=0),
      x = numeric(0),
      flag = integer(0),
      breakpoints = list(),
      logLik = numeric(0),
      hasConfint = logical(0),
      nrSegments = as.integer(NA)
   ),
   validity = validSegmentation) ## see above

##------------------------------------------------------------- 
##   plotSegmentationHeatmap
##------------------------------------------------------------- 
plotSegmentationHeatmap = function(dat, xlim, ylab, rowNames, 
  chr=1, strand="+", vpr, colors, colHeatmap=colorRamp(brewer.pal(9, "YlGnBu")),
  showConfidenceIntervals=TRUE, just=c("left","centre"), main, makeRasterImage = TRUE,...) {

  endVP = FALSE
  if(missing(vpr)) {
     endVP=TRUE
     vpr = newVP(main=main, dataPanelHeight=1, vpHeight=0.95, titleOffSet=-0.9)
  }

  if(min(dat$y, na.rm=TRUE)<0 | max(dat$y, na.rm=TRUE)>1) {
    ythresh = quantile(dat$y, c(0.05,0.95), na.rm=TRUE)
    ymod = dat$y[,,drop=FALSE]
    ymod[ymod<ythresh[1]] = ythresh[1]
    ymod[ymod>ythresh[2]] = ythresh[2]
    dat$y = (ymod - min(ymod, na.rm=TRUE))/(max(ymod, na.rm=TRUE)-min(ymod, na.rm=TRUE))
  }

  xorg  = dat$x
  if(missing(xlim)) {
    xlim=range(dat$x, na.rm=TRUE)
  } else {
    sel = (dat$x>=xlim[1])&(dat$x<=xlim[2])
    dat$x = dat$x[sel]
    dat$y = dat$y[sel,, drop=FALSE ]
    dat$flag = dat$flag[sel]
  }

  defaultColors = c("+" = "#00441b", "-" = "#081d58", "duplicated" = "grey",
                    "cp" = "#555555", "ci" = "#777777", "highlight" = "red", "threshold" = "grey")

  if(!missing(colors)) {
    mt = match(names(colors), names(defaultColors))
    if(any(is.na(mt)))
      stop(paste("Cannot use color specification for", names(colors)[is.na(mt)]))
    defaultColors[mt] = colors 
  }
  colors = defaultColors

  ord = order(dat$x)
  dat$x = dat$x[ord]   ## sort by x-coordinates to simplify smoothing
  dat$y = dat$y[ord,, drop=FALSE]
  dat$flag = dat$flag[ord]
 
  ## Use two viewports for different clipping behavior
  ylim = c(-1, 2+ncol(dat$y))
  pushViewport(dataViewport(xData=xlim, yData=ylim, extension=0, clip="off",
    layout.pos.col=1, layout.pos.row=vpr))

  if(missing(rowNames))
    rowNames = colnames(dat$y)
  if(!is.null(rowNames))
    grid.yaxis((1:ncol(dat$y)), rowNames, gp=gpar(cex=0.5))

  if(!missing(ylab))
    grid.text(ylab, x=-0.075, y=0.5, rot=90)

  pushViewport(dataViewport(xData=xlim, yData=ylim, extension=0, clip="on",
    layout.pos.col=1, layout.pos.row=vpr))

  ord  = c(which(dat$flag!=0), which(dat$flag==0))
  colo = ifelse(dat$flag[ord]==0, colors[strand], colors["duplicated"])
  if(makeRasterImage){
      raster.image(dat$x, 1:ncol(dat$y), z=dat$y, uniq=dat$flag,
              colRamp=colHeatmap,...)
  }else{
      grid.image(dat$x, 1:ncol(dat$y), z=dat$y, uniq=dat$flag,
              colRamp=colHeatmap, just=just)
  }  
  

  ## segment boundaries    
  if(!is.null(dat$estimate) & showConfidenceIntervals) {
     sel = ((xorg[dat$estimate]>=xlim[1]) & (xorg[dat$estimate]<=xlim[2]))
     mySeg = function(j, what)
      grid.segments(x0 = unit(j, "native"), x1 = unit(j, "native"),
                    y0 = unit(-0.1, "npc"),  y1 = unit(1.1, "npc"),
                    gp = gpar(col=colors[what],lty=c(cp=1, ci=2)[what],lwd=2))
    
    if(!is.null(dat$estimate) & sum(sel)>0) {
      mySeg(xorg[dat$estimate][sel], "cp")
      if(!is.null(dat$upper))    mySeg(xorg[dat$upper][sel], "ci")
      if(!is.null(dat$lower))    mySeg(xorg[dat$lower][sel], "ci")
    }
  }

  popViewport(2)  

  if(endVP)
     popViewport(2)

} ## end of plotSegmentationHeatmap

comparisonPlot = function(x, y, xscale=range(x), yscale, anno, ticks, pch=20, cex=1, bgcol="#f2f2f2") {
  
  myColors = function(z){
    brewer.pal(6, "Set1")[c(1,5,3,2)][as.integer(cut(z, quantile(z, c(0, 0.05, 0.35, 0.65, 1)), include.lowest=TRUE))]
  }  
  cols = myColors(rank(y[[1]]))
  
  n = length(y)
  grid.newpage()
  pushViewport(viewport(layout=grid.layout(n+2, 1, heights=c(rep(1,n), 0.2, 0.2))))
  for(i in 1:n) { 
    pushViewport(viewport(layout=grid.layout(2, 2, heights=c(.95, 0.05), widths=c(0.1, 0.9)),
                            layout.pos.col=1, layout.pos.row=i, clip="off"))
    if(i%%2==1) grid.rect(x=0.5, y=0.5, width=1, height=1, default.units="npc",
            gp=gpar(col=bgcol, fill=bgcol))
    pushViewport(viewport(layout.pos.col=1, layout.pos.row=1, clip="off"))
    grid.text(letters[i], x=0, y=0.5, default.units="npc", hjust=0, vjust=0.5,
       gp=gpar(fontface="bold", fontsize=16))
    popViewport()
  
    pushViewport(dataViewport(xscale=xscale, yscale=yscale[,i],
                              layout.pos.col=2, layout.pos.row=1, clip="off"))
    grid.yaxis()
    popViewport()
  
    pushViewport(dataViewport(xscale=xscale, yscale=yscale[,i],
                              layout.pos.col=2, layout.pos.row=1, clip="on"))

    grid.points(x, y[[i]], pch=pch, gp=gpar(col=cols))
    popViewport(2)
  }
  pushViewport(viewport(layout=grid.layout(2, 2, heights=c(.95, 0.05), widths=c(0.1, 0.9)),
                            layout.pos.col=1, layout.pos.row=n+1, clip="off"))
  pushViewport(dataViewport(xscale=xscale, yscale=c(0,1),
                              layout.pos.col=2, layout.pos.row=1, clip="off"))
  grid.lines(xscale, y=c(0.5,0.5), "native")
  for (i in 1:nrow(anno)) {
    grid.rect(x=anno$start[i], y=0.5, width=anno$end[i]-anno$start[i]+1, height=0.7, default.units="native",
              just  = c("left", "center"), gp=gpar(col="black", fill="#d0d0d0"))
    grid.text(x=(anno$start[i]+anno$end[i])/2, y=0.5, label=anno$name[i], default.units = "native")
  }
  grid.segments(x0=ticks*1e3, x1=ticks*1e3, y0=0.4, y1=0.6, default.units="native")
  grid.text(x=ticks*1e3, y=0.3, label=sprintf("%dkB", ticks), just=c("center", "top"), default.units="native")
  popViewport(3)
}

grid.image = function(x, y, z, uniq=uniq,
  colRamp=colorRamp(brewer.pal(9, "YlGnBu")),
  width=22, just=c("left","centre")) {
  
  mcol = (colRamp(z))/256
  mcol[uniq!=0,] = 1
  indna <- is.na(mcol[,1])
  mcol[indna,] = 1

  col = rgb(mcol[,1], mcol[,2], mcol[,3])
  grid.rect(rep(x, ncol(z)), rep(y, each=nrow(z)),just=just,
            width=width, height=1, default.units="native",
            gp=gpar(col=col, fill=col))
}
# the c("left","center") justification is important. The first one
#  is the x-axis (chromosomal coordinate) one.
#  Thus "left" is correct, if the given x-coordinates are the START positions
#  of probes and the segmenation lines should be to the left of them 

###function to interpolate the input coordinates to quiavalent distance
interpolateZ <- function(x,y,xout,space = 8){
    stopifnot(length(x)==length(y))
    if(any(duplicated(x))){
        ind = which(duplicated(x))
        x = x[-ind]
        y = y[-ind]
    }
    xInter.left = pmax(x - space,c(0,x[-length(x)])) ##shift "space" step to the left, if such shift is beyond the adjacent left probe, then we take the position of the left probe 
    xInter.right = pmin(x + space,c(xInter.left[-1],max(x)+space)) ##shift "space" step to the right, if such shift is beyond the ajacent already left shift probes, then we take the position of the left shift probes 
    xAdd = setdiff(xInter.right,xInter.left) ##the missing position that is in the right shift, but not in the left shift should be added and considered as the border that could take a value
    xInsert = c(xInter.left,xAdd)
    yInsert = c(y,rep(-1000,length(xAdd)))
    yInsert[is.na(yInsert)] = -1000 ##this step is very important to make sure that there is no NAs in y,otherwise the interpolate will have problems
    ord = order(xInsert)
    rv = approx(xInsert[ord], yInsert[ord], xout, method="constant", f=0)$y
    rv[rv== -1000] = NA
    return(rv)
}
raster.image = function(x, y, z, uniq=uniq,
        colRamp = colorRamp(brewer.pal(9, "YlGnBu")),
        width = 8,space = 8,...)   ## the typical spacing between neighbouring probes 
{
    
    rg = range(z, na.rm=TRUE)
    if( (rg[1]<0) || (rg[2]>1) )
        warning("rasterImage: 'z' contained values outside [0,1].\n")
    
    nx = nrow(z)
    ny = ncol(z)
    stopifnot(length(x)==nx, length(y)==ny, length(uniq)==nx)
    
    ## equi-distant steps in x and y direction
#    x.equi = seq(x[1], x[nx], length=nx) ##equi distance with the same number of the data points
    x.equi = seq(x[1], x[nx], by=width) ##equi distance with a fixed space witdh
    y.equi = seq(y[1], y[ny], length=ny)
    
    # check that values along y are equi-distant
    stopifnot(all(abs(y-y.equi)<1e-6))
    
    # interpolate z
#    z.equi = apply(z, 2, function(v) approx(x, y=v, xout=x.equi, method="constant", f=0.5)$y)
    z.equi = apply(z, 2, function(v) interpolateZ(x, y=v, xout=x.equi,space = space)) 
	uniq.equi = interpolateZ(x, y=uniq, xout=x.equi,space = space)
	
    mcol = colRamp(as.vector(z.equi)) / 256
	
    mcol[ uniq.equi!=0, ] = 1 ###the uniq.euqi will be re-cycled
    indna <- is.na(mcol[,1])
    mcol[indna,] = 1
    rast = rgb(mcol[,1], mcol[,2], mcol[,3])
    dim(rast) = c(nrow(z.equi), ncol(z.equi))
    
    ## transpose and revert row order
    trsf = function(x) t(x)[seq(from=ncol(x), to=1, by=-1),, drop=FALSE]
    
    grid.raster(image = trsf(rast),
			y = 0.5, height = length(y.equi), hjust=0, #y position starts at 0.5, as the label starts at 0.5, height is the number of hybes 
            x = x.equi[1], width  = x.equi[length(x.equi)] - x.equi[1]+1, vjust=0,
            default.units = "native", interpolate=FALSE)
    
}

# R script to create a tab-delimited flat file containing the probe-wise
## normalized intensities:

## 0. load libraries and data
library(tilingArray)
library(davidTiling)
data(davidTiling)
data(probeAnno)

## where to write the flat file to?
outDir <- "~/temp"

## 1. determine perfect match (PM) probes and background (BG) probes
isPM = logical(nrow(exprs(davidTiling)))
for(j in probeAnno$probeReverse)
  isPM[ as.character(j) != ""] = TRUE
isBG = (probeAnno$probeReverse$no_feature=="no" &
        probeAnno$probeDirect$no_feature=="no")

sum(isPM)
(tab=table(isPM, isBG))
# note: isBG is a subset of isPM

## 2. determine sample type
isRNA = davidTiling$nucleicAcid %in% c("poly(A) RNA","total RNA")
isDNA = davidTiling$nucleicAcid %in% "genomic DNA"
stopifnot(sum(isRNA)==5, sum(isDNA)==3)

## 3. do normalization:
xn2 = normalizeByReference(davidTiling[,isRNA], davidTiling[,isDNA], 
  pm=isPM, background=isBG)
#save(xn2, file="~/temp/xn2.rda")

## 4. write data frame:
arePolyA <- grep("poly",sampleNames(xn2))
areTotal <- grep("totcDNA",sampleNames(xn2))

resultDf <- data.frame()

for (chr in 1:17) { # for all chromosomes
  for (strand in c("+","-")) { # and both strands:
    cat(chr,strand,"...\n")
    # get index of probes on chr and strand:
    thisIdx <- get(paste(chr,strand,"index",sep="."),env=probeAnno)
    nTheseProbes <- length(thisIdx)
    thisPol <- rowMeans(exprs(xn2)[thisIdx,arePolyA])
    thisTot <- rowMeans(exprs(xn2)[thisIdx,areTotal])
    thischrstrDf <- data.frame(Chromosome=I(rep(chr, nTheseProbes)),
                               Strand=I(rep(strand, nTheseProbes)),
                               Start=I(get(paste(chr,strand,"start",sep="."),env=probeAnno)),
                               End=I(get(paste(chr,strand,"end",sep="."),env=probeAnno)),
                               Unique=I(get(paste(chr,strand,"unique",sep="."),env=probeAnno)),
                               PolyA=I(thisPol), Total=I(thisTot))
    resultDf <- rbind(resultDf, thischrstrDf)
  } # for both strands
}# for all chromosomes

# only report those genomic locations uniquely hit by a single probe:
areUnique <- (resultDf$Unique==0)
resultDf <- resultDf[areUnique,]

probeMiddle <- round((resultDf$Start + resultDf$End)/2)
resultDf$Position <- probeMiddle

probeOrder <- order(resultDf$Chromosome, resultDf$Strand, resultDf$Position)

resultDf2 <- resultDf[probeOrder,c("Chromosome","Strand","Position","PolyA","Total")]
resultDf2$PolyA <- round(resultDf2$PolyA, digits=4)
resultDf2$Total <- round(resultDf2$Total, digits=4)

write.table(resultDf2, file=file.path(outDir,"normProbeIntensities.txt"), sep="\t", quote=FALSE,
            row.names=FALSE, col.names=TRUE)

setwd(outDir)
system("zip -r9 normProbeIntensities.zip normProbeIntensities.txt")

plotPenLL = function(seg, extrabar=numeric(0), type="b", lty=1, pch=16, lwd=2, ...) {
  cols = brewer.pal(3, "Set1")
  lls = cbind(logLik(seg), logLik(seg, penalty="AIC"), logLik(seg, penalty="BIC"))

  ylim = c(min(apply(lls, 2, quantile, probs=0.2)), max(lls))
  matplot(lls, col=cols, xlab="S", ylab="(penalized) log likelihood",
          ylim=ylim, 
          type=type, lty=lty, pch=pch, lwd=lwd, ...)

  optBIC = mean(which.max(lls[,3]))
  
  x0 = c(optBIC, extrabar)
  names(x0)[1] = cols[3]
  segments(x0=x0, x1=x0, y0=ylim[1]+diff(ylim)*0.05, y1=ylim[1]+diff(ylim)*0.95,
          col=names(x0), lty=2, lwd=lwd)
  legend(1, ylim[2], expression(log~L, log~tilde(L)[AIC], log~tilde(L)[BIC]),
         xjust=0, yjust=1, col=cols, lwd=lwd, pch=pch)
}

##-------------------------------------------------------------
##   plot Segmentation with Dots
##-------------------------------------------------------------
plotSegmentationDots = function(dat, xlim, ylim, ylab, threshold=NA, 
  chr=1, strand="+", vpr, colors, main, pointSize=unit(0.6, "mm"),
  showConfidenceIntervals=TRUE, sepPlots=FALSE, cexAxisLabel=1, cexAxis=1,...) {

  endVP = FALSE
  if(missing(vpr)) {
     endVP=TRUE
     vpr = newVP(main=main, dataPanelHeight=1, vpHeight=0.95, titleOffSet=-0.9)
  }

  if(is.matrix(dat$y) & !sepPlots)
    dat$y = rowMeans(dat$y) ##  if >1 samples, take mean over samples
  stopifnot(length(dat$y)==length(dat$x), length(dat$flag)==length(dat$x))
  
  xorg  = dat$x
  if(missing(xlim)) {
    xlim=range(dat$x, na.rm=TRUE)
  } else {
    sel  = (dat$x>=xlim[1])&(dat$x<=xlim[2])
    dat$x = dat$x[sel]
    dat$y = dat$y[sel]
    dat$flag = dat$flag[sel]
  }
  
  if(!is.na(threshold)) {
    dat$y = dat$y-threshold
    if(!missing(ylim))
      ylim = ylim-threshold
  }
 
  if(missing(ylim))
    ylim = quantile(dat$y, c(0,1), na.rm=TRUE)

  ## the expression data. use two viewports for different clipping behavior
  if(!missing(ylab)) {
    pushViewport(dataViewport(xData=xlim, yData=ylim, extension=0, clip="off",
      layout.pos.col=1, layout.pos.row=vpr))
    grid.yaxis(gp=gpar(cex=cexAxis),...)
    grid.text(ylab, x=-0.075, y=0.5, rot=90, gp=gpar(cex=cexAxisLabel),...)
    pushViewport(dataViewport(xData=xlim, yData=ylim, extension=0, clip="on",
      layout.pos.col=1, layout.pos.row=vpr))
    }
  else {
    pushViewport(dataViewport(xData=xlim, yData=ylim, extension=0, clip="off",
      layout.pos.col=1, layout.pos.row=vpr))
    grid.yaxis(gp=gpar(cex=cexAxis))
    pushViewport(dataViewport(xData=xlim, yData=ylim, extension=0, clip="on",
      layout.pos.col=1, layout.pos.row=vpr))
    }

  defaultColors = c("+" = "#00441b", "-" = "#081d58", "duplicated" = "grey",
                    "cp" = "#555555", "ci" = "#777777", "highlight" = "red", "threshold" = "grey")

  if(!missing(colors)) {
    mt = match(names(colors), names(defaultColors))
    if(any(is.na(mt)))
      stop(paste("Cannot use color specification for", names(colors)[is.na(mt)]))
    defaultColors[mt] = colors 
  }

  colors = defaultColors

  ord  = c(which(dat$flag!=0), which(dat$flag==0))
  colo = ifelse(dat$flag[ord]==0, colors[strand], colors["duplicated"])

  if(!is.na(threshold))
    grid.lines(y=unit(0, "native"), gp=gpar(col=colors["threshold"]))

  ## segment boundaries
  sel = ((xorg[dat$estimate]>=xlim[1]) & (xorg[dat$estimate]<=xlim[2]))
  mySeg = function(j, what)
    grid.segments(x0 = unit(j, "native"), x1 = unit(j, "native"),
                  y0 = unit(0.1, "npc"),  y1 = unit(0.9, "npc"),
                  gp = gpar(col=colors[what], lty=c(cp=1, ci=2)[what]))
    
  if(!is.null(dat$estimate) & sum(sel)>0) mySeg(xorg[dat$estimate][sel], "cp")
  if(showConfidenceIntervals & sum(sel)>0) {
    if(!is.null(dat$upper))    mySeg(xorg[dat$upper][sel], "ci")
    if(!is.null(dat$lower))    mySeg(xorg[dat$lower][sel], "ci")
  }
  
  grid.points(dat$x[ord], dat$y[ord], pch=20, size=pointSize, gp=gpar(col=colo))
  popViewport(2)

  if(endVP)
     popViewport(2)

} ## plotSegmentationDots

## (c) wolfgang huber 2005
## compute confidence intervals of segmentation(s)
setMethod("confint", "segmentation",
  function(object, parm, level=0.95, het.reg = FALSE, het.err = FALSE, ...)
{
  validObject(object)
  ## the list with breakpoints
  bpL = object@breakpoints

  if(length(bpL)<2)
    stop("length of breakpoints list must be >=2")
  
  ## Check arguments
  if(!missing(parm)) {
    parm = as.integer(parm)
    if(!(is.numeric(parm) &&
         all(parm>1) &&
         all(parm<=length(bpL))))
      stop(sprintf("'parm' must be numeric with values between 2 and %d", length(bpL)))
  } else {
    parm = 2:length(bpL)
  }

  ## transpose: this way the replicate data points (different columns of object@y)
  ##   come after another.
  toy = t(object@y)
    
  ## loop over parm
  for (j in parm) {
    ## Breakpoints:
    ## -- subtract one, since "object@breakpoints" stores the
    ## indices of last points of each segment plus 1 (i.e. the first point of
    ## the next segment), while strucchange expects indices of last points.
    ## -- multiply by nrow(toy) since this is the number of replicates at each
    ## x-position.
    bpj = bpL[[j]][, "estimate"]
    breaks = (bpj-1) * nrow(toy)

    ## Residuals (this really ought to be calculated by the fit function,
    ##  but currently it isn't)
    res = toy
    bp = c(0, breaks, length(toy))
    for(k in 2:length(bp)) {
      rg = (bp[k-1]+1):bp[k]
      res[rg] = res[rg]-mean(res[rg])
    }
    
    ## Assemble a pretend "breakpointsfull" object, with which we can call 
    ## "confint.breakpointsfull" from the strucchange package
    bpp = list(X = matrix(as.integer(1), nrow=length(toy), ncol=1),
               y = toy,
               nobs = length(toy),
               breaks = breaks,
               res = res,
               nreg = NULL, datatsp = NULL)
    class(bpp) = "breakpointsPretend"
    
    ci =  strucchange:::confint.breakpointsfull(bpp, level=level, het.reg=het.reg, het.err=het.err, ...)

    ## extract the confidence intervals and add back 1 to be consistent with our ways
    m = ci$confint
    stopifnot(!is.null(m), all(m[, 2]==breaks))
    m[] = as.integer(round(m/nrow(toy) + 1))
    colnames(m) = c("lower", "estimate", "upper")
    bpL[[j]] = m
    
  } ## for j
  object@breakpoints = bpL
  object@hasConfint[parm] = TRUE
  if(length(parm)==1)
    object@nrSegments=parm
  
  return(object)
})

## argument "breaks" is ignored, it is NULL anyway
residuals.breakpointsPretend = function(object, breaks, ...) {
  stopifnot(is.null(breaks))
  object$res
}

breakpoints.breakpointsPretend = function(obj, breaks, ...) {
  stopifnot(is.null(breaks))
  list(breakpoints =obj$breaks)
}

%\VignetteIndexEntry{Introduction to using the segment function to fit a piecewise constant curve}
%\VignetteDepends{tilingArray}
%\VignetteKeywords{Expression Analysis}
%\VignettePackage{tilingArray}

\documentclass[11pt]{article}
\usepackage{color}
\definecolor{darkblue}{rgb}{0.0,0.0,0.75}

\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rpackage}[1]{\textit{#1}}
\newcommand{\Rfunction}[1]{\textit{#1}}
\newcommand{\Rclass}[1]{\textit{#1}}

\newcommand{\myincfig}[3]{%
  \begin{figure}[htbp]
    \begin{center}
      \includegraphics[width=#2]{#1}
      \caption{\label{#1}#3}
    \end{center}
  \end{figure}
}

\begin{document}


%------------------------------------------------------------
\title{The \Rfunction{segment} function to fit a piecewise constant curve}
%------------------------------------------------------------
\author{Wolfgang Huber}
\maketitle
\tableofcontents

%--------------------------------------------------
\section{A simple example}
%--------------------------------------------------

The problem of segmenting a series of numbers into piecewise constant 
segments occurs in multiple application areas. Two examples are
\begin{itemize}
\item arrayCGH data, where the segments correspond to regions of copy number
  gain, loss, or no change.
\item tiling microarray data for transcription profiling, where the segments
  correspond to transcripts. Here we assume that the probe effects (which lead
  to different fluorescence intensities even for the same mRNA abundance) have
  been normalized away, so that all probes for the same unique target sequence
  have approximately, and in expectation, the same fluorescence.
\end{itemize}

To demonstrate the algorithm, let us generate simulated data:
%
<<defGenData>>=
genData = function(lenx, nrSeg, nrRep=1, stddev=0.1) {
  x  = matrix(as.numeric(NA), nrow=lenx, ncol=nrRep)
  cp = sort(sample(1:floor(lenx/15), nrSeg-1) * 15)
  cpb = c(1, cp, lenx+1)
  s  = 0
  for (j in 2:length(cpb)) {
    sel = cpb[j-1]:(cpb[j]-1)
    s = (.5+runif(1))*sign(rnorm(1))+s
    x[sel, ] = rnorm(length(sel)*nrRep, mean=s, sd=stddev)
  }
  return(list(x=x, cp=cp))
}
@ 
<<plotData,fig=TRUE,include=FALSE>>=
set.seed(4711)
lenx = 1000
nrSeg = 10
gd = genData(lenx, nrSeg)
plot(gd$x, pch=".")
abline(v=gd$cp, col="blue")
@ 
%
\myincfig{findsegments-plotData}{0.6\textwidth}{%
A simulated data example with \Sexpr{nrSeg} segments.
Their estimated locations are shown with blue vertical lines}
%
The result is shown in Figure~\ref{findsegments-plotData}.
We can use the function \Rfunction{segment} to reconstruct the
change-points from the data in \Robject{gd\$x} alone.
%
<<loadlib, results=hide>>=
library("tilingArray")
@ 
<<findSegments>>=
maxseg = 12
maxk = 500
seg  = segment(gd$x, maxk=maxk, maxseg=maxseg)
seg
seg@breakpoints[nrSeg+(-1:1)]
gd$cp
@ 
%
<<checkClaim, echo=FALSE>>=
stopifnot(all(gd$cp==seg@breakpoints[[nrSeg]]))
@ 
%
We see that the \Sexpr{nrSeg}-th element of the list \Robject{seg\@breakpoints} 
exactly reconstructs the change-points \Robject{gd\$cp} that were 
used in the simulation.

The parameters \Robject{maxseg} and \Robject{maxk} are the maximum
number of segments and the maximum length per segment. The algorithm
finds for each value of $k$ from \Robject{1} to \Robject{maxseg} the
best segmentation under the restriction that no individual segment be
longer than \Robject{maxk}.  In the paper of Picard et
al.~\cite{Picard} and in their software, \Robject{maxk} is implicitely
set to the number of data points \Robject{length(x)}. I have
introduced this parameter to reduce the algorithm's complexity. The
complexity of Picard's software is \Robject{length(x)*length(x)} in
memory and \Robject{length(x)*length(x)*maxcp} in time, the complexity
of the \Rfunction{segment} function is \Robject{length(x)*maxk} in
memory and \Robject{length(x)*maxk*maxcp} in time. As I am applying it
to data with \Robject{length(x)} $\approx 10^5$ and \Robject{maxk}
$\approx 250$, the difference can be substantial.

%-----------------------------------------------------------------------------------------
\section{More testing of the change-point estimates on simulated data}
%-----------------------------------------------------------------------------------------
Here is a little for-loop that generates data using random parameters 
and checks whether \Rfunction{segment} can reconstruct them. 
%
<<testCP>>=
for(i in 1:20){
  gd  = genData(lenx, nrSeg)
  seg = segment(gd$x, maxk=maxk, maxseg=maxseg)
  stopifnot(seg@breakpoints[[nrSeg]][, "estimate"] == gd$cp)
}
@ 

%-----------------------------------------------------------------------------------------
\section{Model selection on simulated data}
%-----------------------------------------------------------------------------------------
In this section we show that the BIC works pretty well for finding the
correct number of segments (parameter $S$ in the paper) \emph{if} the
data are generated by the model.
%
<<modelSelect1>>=
nrSeg = 22
gd = genData(lenx, nrSeg, nrRep=2, stddev=1/3)
s = segment(gd$x, maxk=lenx, maxseg=as.integer(nrSeg * 2.5))
@ 
%
Plot the segmented data (Figure~\ref{fig:penLLsim}a)
%
<<plotSimSeg,fig=TRUE,include=FALSE,width=5,height=5>>=
par(mai=c(1,1,0.1,0.01))
plot(row(gd$x), gd$x, pch=".")
@ 
%
and the log likelihoods and the penalized log likelihoods.
This is similar to what is done in the segmentation.Rnw vignette for \emph{real} data.
%
and call it it:
<<penLLsim,fig=TRUE,include=FALSE,width=5,height=5>>=
par(mai=c(1,1,0.1,0.01))
plotPenLL(s)
@ 
%
The result is shown in Figure~\ref{fig:penLLsim}b.
%
<<printMaxima>>=
which.max(logLik(s, penalty="AIC"))
which.max(logLik(s, penalty="BIC"))
@ 
%  
\begin{figure}[htbp]
\begin{center}
\includegraphics[width=0.5\textwidth]{findsegments-plotSimSeg}
\includegraphics[width=0.5\textwidth]{findsegments-penLLsim}

\caption{\label{fig:penLLsim}%
a) simulated data example with \Robject{nrSeg=}\Sexpr{nrSeg}
segments and vertical lines representing the fitted model with
$S=$\Sexpr{which.max(logLik(s, penalty="BIC"))}, 
selected by maximum $\log L_{\mbox{\scriptsize BIC}}$.  
b) log-likelihood $\log L$, penalized
likelihoods $\log\tilde{L}_{\mbox{\scriptsize AIC}}$ and 
$\log\tilde{L}_{\mbox{\scriptsize BIC}}$.}
\end{center}
\end{figure}


%--------------------------------------------------
\begin{thebibliography}{10}
%--------------------------------------------------

\bibitem{Picard}
A statistical approach for CGH microarray data analysis.
\newblock Franck Picard, Stephane Robin, Marc Lavielle, Christian Vaisse,
  Gilles Celeux, Jean-Jacques Daudin.
\newblock Rapport de recherche No. 5139, Mars 2004,
  \textit{Institut National de Recherche en Informatique et en Automatique (INRIA)},
  ISSN 0249-6399.
  http://www.inapg.fr/ens\_rech/mathinfo/recherche/mathematique/outil.html

\end{thebibliography}
\end{document}

%\VignetteIndexEntry{Introduction to the plotAlongChrom function}
%\VignetteDepends{tilingArray,RColorBrewer}
%\VignettePackage{tilingArray}
% 
\documentclass[11pt,a4wide]{article}
\usepackage[margin=2cm,nohead]{geometry}
\usepackage{color}
\definecolor{darkblue}{rgb}{0.0,0.0,0.75}
\usepackage[%
baseurl={http://www.bioconductor.org},%
pdftitle={Introduction to the plotAlongChrom function},%
pdfauthor={Zhenyu Xu},%
pdfsubject={tilingArray},%
pdfkeywords={Bioconductor},%
pagebackref,bookmarks,colorlinks,linkcolor=darkblue,citecolor=darkblue,%
pagecolor=darkblue,raiselinks,plainpages,pdftex]{hyperref}
\usepackage{Sweave}
\SweaveOpts{keep.source=TRUE,eps=FALSE,include=FALSE,width=5,height=5} 
%------------------------------------------------------------
% newcommand
%------------------------------------------------------------
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\Rpackage}[1]{\textit{#1}}
\newcommand{\Rclass}[1]{\textit{#1}}
\newcommand{\Rfunction}[1]{{\small\texttt{#1}}}
\newcommand{\mbs}[1]{{\mbox{\scriptsize #1}}}

\newcommand{\myincfig}[3]{%
  \begin{figure}[htbp]
    \begin{center}
      \includegraphics[width=#2]{#1}
      \caption{\label{#1}#3}
    \end{center}
  \end{figure}
}
\begin{document}

%------------------------------------------------------------
\title{Introduction to the plotAlongChrom function}
%------------------------------------------------------------
\author{zhenyu}

\maketitle

%----------------------------------------
\section{Introduction to the example data}
%----------------------------------------
The purpose of this vignette is to demonstrate some of the functionalities of the 
\Rfunction{plotAlongChrom} in the \Rpackage{tilingArray}
package. We use a small subset data from an expression profiling paper \cite{Xu2009}; The data
only include the region from 35000bp to 50000bp in yeast chromosome one. Expression profiling 
is done in YPE and YPD conditions, 3 replicates each. Further information about the experimental design 
can be found at the paper website {http://steinmetzlab.embl.de/NFRsharing/}.
<<load, results=hide>>=
library("grid")
library("RColorBrewer")
library("tilingArray")
@ 
<<errorReporting, echo=FALSE>>=
options(error=recover, warn=0, digits=3)
@ 
<<showTilingArrayData>>=
data("segnf")
class(segnf)
ls(segnf)
segnf$"1.+"
head(segnf$"1.+"@y)
dim(segnf$"1.+"@y)
head(segnf$"1.+"@x)
length(segnf$"1.+"@x)
segnf$"1.+"@logLik
segnf$"1.+"@nrSegments
head(segnf$"1.+"@breakpoints[[segnf$"1.+"@nrSegments]])
@ 
The \Robject{segnf} object is an environment which contains two objects of class \Rclass{segmentation}.    
\Robject{segnf} is the output of the \Rfunction{segChrom} in the \Rpackage{tilingArray} package.
The \Rclass{segmentation} object in \Robject{segnf} stores the probe expression information in the slot
\Robject{y}. As can be seen, it contains 1775 probes and 6 array hybes in two conditions. The genomic
coordinates where the probes aligned to is stored in the slot \Robject{x}. The order of the slot \Robject{x}
is the same as the probe row order in slot \Robject{y}. The segment boundary information is stored 
in the slot \Robject{breakpoints} which is a list that contains all the optimal placement of 1 segment to the
designate number(here in this data set is 17) of segments for this data. A log likelihood
score for each placement is stored in slot \Robject{logLik} from which the best one is choosen and stored
in the slot \Robject{nrSegments}. Further information about how the segmentation algorithm works, please 
read the vignette segmentation demo.

<<gffSub>>=
data(gffSub)
head(gffSub)
@
The \Robject{gffSub} object is a data frame that contains the SGD annotated features of the region 35000bp-50000bp
for yeast chromosome one.

%----------------------------------------
\section{Visualizing the expression profiling with the plotAlongChrom function}
%----------------------------------------
The function \Rfunction{plotAlongChrom} accepts an environment as its
first argument, which is expected to contain objects of class
\Rclass{segmentation} with names given by 
\Robject{paste(chr, c("+", "-"), sep=".")}, where \Robject{chr} is the
chromosome identifier. 

The following code generates Figure~\ref{plotAlongChrom-alongChromDot1}, a dot plot that averaged across all hybes.
<<alongChromDot1,fig=TRUE, eps=FALSE, include=FALSE, width=16, height=6,echo=TRUE>>=
grid.newpage()
plotAlongChrom(segnf,chr=1, coord=c(35000,50000),what="dots", gff=gffSub)
@
\myincfig{plotAlongChrom-alongChromDot1}{0.96\textwidth}{% 
Along-chromosome dot plot of the averaged value across all hybes.}

We could also make separate dot plot for different hybes by setting the parameter \textit{sepPlot} as TRUE. The 
following code generates Figure~\ref{plotAlongChrom-alongChromDot2} that plots the expression separately for the two 
conditions.
<<alongChromDot2,fig=TRUE, eps=FALSE, include=FALSE, width=16, height=8,echo=TRUE>>=
segObj = new.env(parent = baseenv())
nmLabel = colnames(segnf$"1.+"@y)
lab = gsub("\\d","",nmLabel)
for(nm in paste(1,c("+","-"),sep=".")){
    s = get(nm,env = segnf)
    rpY =  tapply(1:length(lab),lab,function(i)rowMeans(s@y[,i]))
    s@y = do.call(cbind,rpY)
    assign(nm,s,segObj)
}
grid.newpage()
plotAlongChrom(segObj,chr=1, coord=c(35000,50000),what="dots", gff=gffSub,sepPlot = T)
@

\myincfig{plotAlongChrom-alongChromDot2}{0.96\textwidth}{% 
Along-chromosome dot plot of the averaged value among different replicates for YPD and YPE condition.}
 
However, with the number of hybes increases, it is very hard to see the difference 
in dot plots in a normal screen. Thus, if the number of hybes is more than 4, the function will 
force to take the average. A better alternative of displaying multiple hybes is to use the heatmap.        
The following code generates Figure~\ref{plotAlongChrom-alongChromHeatmap1} that makes the heatmap plot.
<<alongChromHeatmap1,fig=TRUE, eps=FALSE, include=FALSE, width=16, height=6>>=
grid.newpage() 
plotAlongChrom(segnf,chr=1, coord=c(35000,50000),what="heatmap", gff=gffSub,
         rowNamesHeatmap=nmLabel,makeRasterImage=FALSE)
@

\myincfig{plotAlongChrom-alongChromHeatmap1}{0.96\textwidth}{% 
Along-chromosome heatmap plot of all the replicates in YPD and YPE condition.}
 
Start with R 2.11.0, the \Rpackage{grid} package introduced the raster array image function 
\Rfunction{grid.raster} which is a faster and efficient way of generating heatmap images. From R 2.11.0, The  
\Rpackage{tilingArray} package will use the \Rfunction{grid.raster} function as default to make heatmap
images replacing the previous \Rfunction{grid.rect} function. The choice between the two drawing functions
can be changed by the parameter \textit{makeRasterImage}. The following code generates 
Figure~\ref{plotAlongChrom-alongChromHeatmap2} that makes the raster heatmap plot.

<<alongChromHeatmap2,fig=TRUE, eps=FALSE, include=FALSE, width=16, height=6>>=
grid.newpage() 
plotAlongChrom(segnf,chr=1, coord=c(35000,50000),what="heatmap", gff=gffSub,
         rowNamesHeatmap=nmLabel,makeRasterImage=TRUE)
@

\myincfig{plotAlongChrom-alongChromHeatmap2}{0.96\textwidth}{% 
Along-chromosome raster heatmap plot of all the replicates in YPD and YPE condition.}

The color gradient of the heatmap could be changed by the parameter \textit{colHeatmap}.
The following code generates Figure~\ref{plotAlongChrom-alongChromHeatmap3} 
that makes the raster heatmap plot using a blue color gradient.
<<alongChromHeatmap3,fig=TRUE, eps=FALSE, include=FALSE, width=16, height=6>>=
grid.newpage() 
plotAlongChrom(segnf,chr=1, coord=c(35000,50000),what="heatmap", gff=gffSub,
         rowNamesHeatmap=nmLabel,makeRasterImage=TRUE,
         colHeatmap = colorRamp(brewer.pal(9, "Blues")))
@

\myincfig{plotAlongChrom-alongChromHeatmap3}{0.96\textwidth}{% 
Along-chromosome raster heatmap plot of all the replicates in YPD and YPE condition with a blue 
color gradient.}

%------------------------------------------------------------
\begin{thebibliography}{10}

\bibitem{Xu2009} Zhenyu Xu, Wu Wei, Julien Gagneur, Fabiana Perocchi, 
Sandra Clauder-Munster, Jurgi Camblong, Elisa Guffanti, Francoise Stutz, 
Wolfgang Huber and Lars M. Steinmetz \newblock Bidirectional promoters generate 
pervasive transcription in yeast.  \newblock \textit{Nature}, 2009.

\end{thebibliography}
\end{document}

\name{tilingArray-package}
\alias{tilingArray-package}
\alias{tilingArray}
\docType{package}
\title{tilingArray package overview}
\description{
   tilingArray package overview
}
\details{
  The package provides some functionalities that can be useful for the
  analysis of high-density tiling microarray data (such as Affymetrix
  genechips) for measuring transcript abundance and architecture.
  The main functionalities of the package are:
  
  \itemize{
    \item The segmentation class
     for representing partitionings of a linear series of data (such as
     microarray intensity readings along a chromosome strand).
   \item The function \code{\link{segment}}
     for fitting piecewise constant models using a dynamic programming
     algorithm that is both fast and exact,
     and \code{\link[tilingArray:class-segmentation]{confint}} for
     calculating confidence intervals using the strucchange package.
     Please see the vignette \emph{Segmentation demo} in the file
     inst/doc/segmentation.pdf (source file inst/scripts/segmentation.Rnw).
   \item The function \code{\link{plotAlongChrom}} for generating pretty
     plots of segmentations along with genomic features. Please also see
     the vignette \emph{Segmentation demo}.
   \item The function \code{\link{normalizeByReference}}
     for probe-sequence dependent response adjustment from 
     a (set of) reference hybridizations.
     Please see the vignette \emph{Assessing signal/noise ratio before
    and after normalization} in the file 
     inst/doc/assessNorm.pdf (source file inst/scripts/assessNorm.Rnw).
     }
}
\author{
   W. Huber <huber@ebi.ac.uk>
}
\keyword{package}

\name{normalizeByReference}
\alias{normalizeByReference}

\title{
  Probe-specific normalization of hybridization intensities from an oligonucleotide microarray
}
\description{
  Adjust the hybridization intensities from an oligonucleotide microarray
  for probe-specific response effect by using one or several reference
  hybridizations.
  If \code{x} contains more than one array, \code{\link[vsn:vsn2]{vsnMatrix}} from
  the \code{vsn} package is called for between array normalization.
}
\usage{
normalizeByReference(x, reference, pm, background, refSig, nrStrata=10,
  cutoffQuantile=0.05, plotFileNames, verbose=FALSE)
}
\arguments{
  \item{x}{ExpressionSet containing the data to be normalized.}
  \item{reference}{ExpressionSet with the same number of features as \code{x},
    containing the reference signal, on the raw scale (non-logarithmic).
    This argument can be used to directly input the data from a set of
    replicate DNA hybridizations.
    Alternatively, the argument \code{refSig} can be specified.}
  \item{pm}{Indices specifying the perfect match features in
    \code{reference} (see Details).
    This can be either an integer vector with values between 1 and
    \code{nrow(exprs(reference))} or a logical vector.}
  \item{background}{Indices specifying a set of background features in
    \code{x} (see Details).
    This can be either an integer vector with values between 1 and
    \code{nrow(exprs(x))} or a logical vector.}
  \item{refSig}{A numeric vector of the same length as \code{pm} with
    estimates of probe response effects, on a logarithm-like scale.
    This argument can be specified alternatively to \code{reference}.}
  \item{nrStrata}{Integer (length 1), number of strata for the estimation of
    the background function.}
  \item{cutoffQuantile}{Numeric (length 1), the probes whose reference
    signal is below this quantile are thrown out.}
  \item{plotFileNames}{Character vector whose length is the same as the
    number of arrays in \code{x}. Optional, if missing, no plots are
    produced.}
  \item{verbose}{Logical of length 1, if \code{TRUE}, some messages about
    progress are printed.}
}
\details{The intensities in \code{x} are adjusted according to the
  reference values.
  Typically, the reference values are obtained by hybridizing a DNA
  sample to the array, so that the abundance of target is
  the same for all reference probes, and their signal can be used to estimate
  the probe sequence effect. A reference probe is a probe that
  perfectly matches the target genome exactly once.
  Usually, not all probes on a chip are reference
  probes, hence the subset of those that are is specified by the
  argument \code{pm}.

  The background signal is estimated from the probes indicated by the
  argument \code{background}. They need to be a strict subset of the
  \code{reference} probes. I.e., they need to uniquely
  match the target organism's DNA, but are not expected to match any of its transcripts. A
  robust estimation method is used, so a small fraction of
  \code{background} probes that do hit transcripts is not harmful.

  A limitation of this normalization method is that it only makes sense
  for the data from reference probes, NA values are returned for all other probes.

  The functions \code{PMindex} and \code{BGindex} can be used to produce
  the \code{pm} and \code{background} arguments from a \code{probeAnno}
  environment such as provided in the davidTiling package.

  To summarize, a reference probe (indicated by argument \code{pm}) is a
  probe that perfectly matches the target genome exactly once, a
  background probe (indicated by argument \code{background})
  is a reference probe which we expect not to be transcribed. These
  should not be confused with what is called 'perfect match' and
  'mismatch' probes in Affymetrix annotation.
}

\seealso{\code{PMindex}, \code{BGindex}}

\value{
  A copy of \code{x} with the normalized intensities.
}

\author{W. Huber \email{huber@ebi.ac.uk}}

\references{The method implemented in this function is described in
  detail in Section 2.3 of the article
  Huber W, Toedling J, Steinmetz, L. Transcript mapping with
  high-density oligonucleotide tiling arrays. Bioinformatics 22, 1963-1970 (2006).}
\examples{
  ## see vignette assessNorm.Rnw in inst/scripts directory
}
\keyword{manip}

\name{findSegments}
\alias{findSegments}

\title{Fit a piecewise constant curve to a sequence of numbers  --
  OBSOLETE, please use function segment instead.}
\description{
  This function is only here for backward compatibility - please use
  \code{\link{segment}}.
  
  The function fits a piecewise constant curve to a sequence of numbers
  using a simple least squares cost function and the dynamic programming
  algorithm described by Picard et al. (see reference).
}
\usage{
findSegments(x, maxcp, maxk, verbose=TRUE)
}
\arguments{
  \item{x}{Numeric (real) vector.}
  \item{maxcp}{Integer (length 1): maximum number of segments (= 1 + maximum
    number of change points).}
  \item{maxk}{Integer (length 1): maximum length of a segment.}
  \item{verbose}{Logical: if this parameter has a positive
    value, various diagnostic output is printed.}
}
\details{The complexity of the algorithm is 
\code{length(x)*maxk} in memory and
\code{length(x)*maxk*maxcp} in time.}

\value{
  An object of class \code{"segmentation"}
  A list with elements
  \item{J}{likelihood criterion}
  \item{th}{matrix of segment start points}
  \item{dat}{the data used for the segmentation}
  \item{call}{the function call}.

  See the vignette, and
  the paper cited below for details.
}

\note{This function is depracated and replaced by function
  \code{segment}, but still included for backward compability. 
}

\author{W. Huber \email{huber@ebi.ac.uk}, Joern Toedling
  \email{toedling@ebi.ac.uk}}

\references{A statistical approach for CGH microarray data analysis.
  Franck Picard, Stephane Robin, Marc Lavielle, Christian Vaisse,
  Gilles Celeux, Jean-Jacques Daudin,
  Rapport de recherche No. 5139, Mars 2004,
  Institut National de Recherche en Informatique et en Automatique (INRIA),
  ISSN 0249-6399.
  The code of this function is based on the Matlab
  implementation presented at  
  \url{http://www.inapg.fr/ens_rech/mathinfo/recherche/mathematique/outil.html},
  but it has evolved.}


\examples{
 x = rep( sin((0:4)/2*pi), each=3) + rnorm(3*5, sd=0.1)
 res = findSegments(x, maxcp=6, maxk=15)
}
\keyword{manip}

\name{segnf}
\alias{segnf}
\title{Example of a segmentation output object }
\description{Example of a segmentation output object}
\usage{
  data(segnf)
}
\details{
  segnf is an environment which contains two segmentation object for the "+"
  and "-" strand of yeast chromosome one. Each segmentation object contains
  the tiling array expression profiling between condition YPE and YPD, 3 replicates each.
  The raw array data are normalized, mapped to the yeast genome and segmented using the
  segChrom function. The object is the output of segChom with some small modification.
  Only a small region (35000bp-50000bp) is included in this data     	  
}

\author{Zhenyu Xu <zhenyu@ebi.ac.uk>}

\examples{
  data(segnf)
  data(gffSub)
  nmLabel = colnames(segnf$"1.+"@y)
  plotAlongChrom(segnf,chr=1, coord=c(35000,50000),what="heatmap", 
  		gff=gffSub,rowNamesHeatmap=nmLabel)
}
\keyword{data}

\name{costMatrix}
\alias{costMatrix}
\title{Segmentation cost matrix}
\description{
  This function calculates the cost matrix for the segmentation model
}
\usage{
costMatrix(x, maxk)
}
\arguments{
  \item{x}{Numeric vector of length \code{n} or matrix with \code{n} rows and \code{d}
    columns, where \code{n} is the number of sample points and \code{d}
    the number of replicate measurements (e.g. from multiple arrays).}
  \item{maxk}{Positive integer.}
}
\details{
  See the package vignette \emph{Calculation of the cost matrix}.
}

\value{
  Matrix with \code{maxk} rows and \code{length(x)} columns.
}

\author{W. Huber}

\examples{
d = 4
x = apply(matrix(rnorm(200), ncol=d), 2, cumsum)
maxk = 50
 
G = costMatrix(x, maxk=maxk)
 
G.pedestrian = matrix(NA, nrow=nrow(G), ncol=ncol(G))
for(i in 1:(ncol(G)))
  for(k in 1:min(nrow(G), nrow(x)-i+1))
    G.pedestrian[k, i] = (k*d-1)*var(as.vector(x[i:(i+k-1), ]))
 
stopifnot(identical(is.na(G), is.na(G.pedestrian)))
stopifnot(max(abs(G-G.pedestrian), na.rm=TRUE) <= 1e-6)
}
\keyword{manip}

\name{plotFeatures}
\alias{plotFeatures}
\title{Plot genomic features for a region along a chromosome}
\keyword{hplot}
\description{Plot genomic features for a region along a chromosome}

\usage{
plotFeatures(gff, chr, xlim, strand, vpr, featureColorScheme=1, 
             featureExclude=c("chromosome", "nucleotide_match", "insertion"),            
             featureNoLabel=c("uORF", "CDS"), ...)
}

\arguments{
  \item{gff}{data frame with genome annotation from the GFF file.}
  \item{chr}{integer of length 1 specifying the chromosome to plot the features for.}
  \item{xlim}{integer of length 2 with start and end coordinates (in bases) for plotting.}
  \item{strand}{character scalar which should be set to either \code{+} or \code{-} to 
    indicate which strand of DNA to plot the features from.}
  \item{vpr}{which viewport to plot the features in.}
  \item{featureColorScheme}{numeric scalar, used to select a color scheme for the 
   boxes representing genomic features such as coding sequences, ncRNAs etc. 
   Currently the only value supported is 1.}
  \item{featureExclude}{character vector of names of feature types (in
    gff) that should not be plotted. Default is \code{"chromosome"}, \code{"nucleotide_match"} and 
    \code{"insertion"}.  Additional possible candidates include: \code{"ARS"}, \code{"repeat\_region"},
    \code{"repeat\_family"} and \code{"nc\_primary\_transcript"}.}
  \item{featureNoLabel}{character vector, names of feature types (in
    gff) that should not be labelled with their names (if they are plotted).}
  \item{...}{additional arguments.}
}

\details{
  This function is called by \code{plotAlongChrom} when the \code{gff} argument has been specified.  It should not be called directly by the user.}
      
\author{Wolfgang Huber <huber@ebi.ac.uk>}

\name{otherStrand}
\alias{otherStrand}
\title{Return the name of the opposite strand}
\description{Return the name of the opposite strand}
\usage{
otherStrand(x)
}
\arguments{
  \item{x}{Character vector whose elements are "+" or "-".}
}
\details{
  This is a rather trivial convenience function.

  An alternative would be to code strands with integers \code{-1} and
  \code{+1}, in which case the inversion would be a trivial builtin
  operation. However, many genomic databases and input data files use
  the character string / factor notation.
}

\value{
  Character vector of same length as \code{x}, with strands reversed.
}

\author{W. Huber <huber@ebi.ac.uk>}

\examples{
  otherStrand(c("+", "-"))
}
\keyword{manip}

\name{segChrom}
\alias{segChrom}

\title{Fit a piecewise constant curve to along chromosome data (wrapper function)}
\description{
  Wrapper around the \code{segment} function for each strand of one or
  more chromosomes specified by the user. It does some typical
  preprocessing and I/O.
}
  
\usage{
segChrom(y, probeAnno, chr=1:17, strands=c("+", "-"), 
  nrBasesPerSegment = 1500, maxk = 3000, step = 7, confint = FALSE,
  confintLevel = 0.95, useLocks=TRUE, verbose=TRUE, savedir)
}

\arguments{  
  \item{y}{ExpressionSet or matrix containing the data to be segmented.}
  \item{probeAnno}{an object of class \code{probeAnno} (defined in the
  Ringo package) or an environment with probe annotations. For the
  latter, see the package \code{davidTiling} for an example (?probeAnno).}
  \item{chr}{integer scalar or vector specifying which chromosome(s) to segment.}
  \item{strands}{character scalar or vector specifying which strands to
  segment; can also be \code{NA}.}
  \item{nrBasesPerSegment}{integer (length 1): the parameter
    \code{maxseg} of the \code{\link{segment}} function is calculated as
    the length of the chromosome divided
    by \code{nrBasesPerSegment}. Thus, it determines the average segment
    length in the finest segmentation.}
  \item{maxk}{passed on to  the function \code{\link{segment}}.}
  \item{step}{integer scalar, indicating the minimum distance between
    consecutive probes. In cases when probes are offset by less than
    \code{step} bases, the probes are sampled to achieve the desired spacing.}
  \item{confint}{logical scalar.  If \code{TRUE}, confidence intervals
    for each change-point are calculated.}
  \item{confintLevel}{numeric scalar between 0 and 1 indicating the
    probability level for the confidence intervals that are calculated
    for each change-point.}
  \item{useLocks}{logical scalar. Should a file locking mechanism be used
    that allows for a simple-minded parallelization of this function.}
  \item{verbose}{logical scalar. Should we be chatty about our progress?}
  \item{savedir}{character scalar. If specified, resulting \code{segmentation}
    objects are saved (with \code{\link{save}}) to this directory.}

}

\details{
  This function is a wrapper for the \code{\link{segment}} function.
  It is provided in this package for illustration. For applications to
  different datasets, you will likely need to adapt it to some extent,
  please refer to its source code.
}

\value{
  An environment containing S4 objects of class \code{"segmentation"}
  called "1.+", "1.-", etc. (depending on the values in \code{chr} and
  \code{strands}),
  where "+" and "-" indicate the strand and the preceding number refers
  to the chromosome.
  If \code{savedir} is specified, there is also the side-effect that
  a series of files "1.+.rda", "1.-.rda", etc. is saved in that directory.}

\author{Wolfgang Huber <whuber@embl.de>}

\examples{
\dontrun{
  library("davidTiling")
  data("davidTiling")
  data("probeAnno")
  isDNA = seq(1:3)
  yn = normalizeByReference(davidTiling[,-isDNA],davidTiling[,isDNA], probeAnno=probeAnno)
  seg = segChrom(yn, probeAnno) ## this will take a while to run!
}
}
\keyword{manip}

\name{readCel2eSet}
\alias{readCel2eSet}
\title{Read celfiles into an ExpressionSet object.}
\description{
  This is a wrapper for \code{\link[affy:read.affybatch]{ReadAffy}} that
  returns an \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}
  object rather than an 
  AffyBatch. This is particularly usefiles for arrays for which we have
  or need no CDF environment.
}
\usage{
readCel2eSet(filename, adf, path=".", rotated=FALSE, ...)
}
\arguments{
  \item{filename}{Character vector with CEL file names. Either
    \code{filename} or \code{adf} need to be specified, but not both.}
  \item{adf}{Object of class
    \code{\link[Biobase:class.AnnotatedDataFrame]{AnnotatedDataFrame}}.}
  \item{path}{Character scalar with path to CEL files.}
  \item{rotated}{Logical scalar, see details.}
  \item{...}{Further arguments that are passed on to
    \code{new("ExpressionSet")}.}
}
\details{
  The \code{rotate} options allows to deal with different versions of
  the scanner software. Older versions rotated the image by 90 degrees,
  newer ones do not. Use the default \code{rotated=FALSE} for CEL files
  produced by the newer version.
}

\value{
  \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object.
}

\author{W. Huber}

\examples{
## To test the rotation, look at the scatterplot between two DNA hybes
## that were measured with scanner software that rotated (041120) and did
## not rotate (060125)
##
## cp /ebi/research/huber/Projects/tilingArray/Celfiles/041120_S96genDNA_re-hybe.cel.gz ~/p/tmp
## cp /ebi/research/huber/Projects/allelicTranscription/celfiles_allelictrans/060125_S96_genomicDNA.zip ~/p/tmp
## cd ~/p/tmp
## gunzip 041120_S96genDNA_re-hybe.cel.gz
## unzip 060125_S96_genomicDNA.zip
##
\dontrun{
library("affy")
options(error=recover)

e1 = readCel2eSet("041120_S96genDNA_re-hybe.cel", rotated=TRUE)
e2 = readCel2eSet("060125_S96_genomicDNA.CEL")

smoothScatter(log(exprs(e1)), log(exprs(e2)), nrpoints=0)
}
}
\keyword{manip}

\name{qcPlots}
\alias{qcPlots}
\title{Generate simple diagnostic plots for Affymetrix tiling array data}
\keyword{hplot}
\description{Generate simple diagnostic plots for Affymetrix tiling array data}

\usage{
qcPlots(x, html=TRUE, plotdir=NULL, probeAnno, gff, 
                    chr=4, coord=c(230000,245000),
  		    nr = 2560, nc = 2560,
		    ylimchrom=c(5,16), nucleicAcid, pmindex, pgm=TRUE,
                    ext=".cel", ranks=FALSE, ...)
}

\arguments{
  \item{x}{ExpressionSet containing the data to be plotted.}
  \item{html}{logical scalar.  If \code{TRUE} an html summary page 
              'qcsummary.htm' is generated.  If \code{FALSE}, no summary page is generated.}
  \item{plotdir}{optional character string specifying the filepath where the plots will be saved.  Defaults to current working directory.}
  \item{probeAnno}{environment with probe annotations. See
    package \code{davidTiling} for an example (?probeAnno).}
  \item{gff}{data frame with genome annotation from the GFF file.} 
  \item{chr}{integer of length 1 indicating the chromosome number to plot.}
  \item{coord}{integer vector of length 2 containing the start and end coordinates (in
    bases) for the along chromosome intensity plot.}
  \item{nr}{integer, indicating the number of probes in each row on the array (2560 for yeast tiling arrays).}
  \item{nc}{integer, indicating the number of probes in each column on the array (2560 for yeast tiling arrays).}
  \item{ylimchrom}{numeric vector containing the y limits of the along chromosome intensity plot.}
  \item{nucleicAcid}{character vector or factor indicating what sample has been hybridised to each
array. Used to color the boxplots and smoothed histograms of intensities.}
  \item{pmindex}{integer vector of indices of PM probes in \code{x}.  If missing, this information is extracted from \code{probeAnno}.}
  \item{pgm}{logical scalar.  If \code{TRUE}, image plots will be saved as .pgm files.  Otherwise (\code{FALSE}), they are converted to jpegs. On windows machines, this argument should be set to \code{TRUE}.}
  \item{ext}{character string indicating the file extension.}
  \item{ranks}{logical scalar.  If \code{TRUE}, imageplots will show ranks of standardised probe intensities.  Otherwise (\code{FALSE}, default), the standardised probe intensities are plotted.}
  \item{...}{further arguments that can be passed to the plotting function \code{plotSegmentationDots}.}
}

\details{
  This function creates boxplots, smoothed histogram (density) plots, imageplots and 
  along chromosome plots of the raw (log base 2) probe intensity data.
  
  An html page called 'qcsummary.htm' which displays the results, is created when \code{html=TRUE}. 

  Imageplots of standardised intensities (i.e. (probe intensity - minimum probe intensity) divided by the difference between the maximum and minimum probe intensities, all on log base 2 scale) or the ranks of these standardised intensities are plotted depending on the \code{ranks} argument. 

  The individual plots are named by replacing the file extension (specified by \code{ext}) of each 'celfile.ext', with 'density.png' for smoothed histogram plots, 'gencoord.jpg', for along chromosome plots and either 'log.pgm' ('log.jpg' if \code{pgm=FALSE}) or 'rank.pgm' ('rank.jpg' if \code{pgm=FALSE}) for the imageplots, depending on the \code{ranks} argument.
}

\author{Matt Ritchie <ritchie@ebi.ac.uk> and Wolfgang Huber <huber@ebi.ac.uk>}
\examples{## library(davidTiling)
## data(davidTiling)
## data(probeAnno)
## qcPlots(davidTiling, probeAnno)
 }

\name{segmentation}
\docType{class}
\alias{segmentation-class}

\alias{confint}
\alias{logLik}
\alias{confint,segmentation-method}
\alias{logLik,segmentation-method}
\alias{plot,segmentation,ANY-method}
\alias{show,segmentation-method}

\concept{plot}
\concept{show}
\concept{confint}
\concept{logLik}

\title{
  The class segmentation represents a segmentation result.
}
\description{
  This class represents the result of a segmentation, usually
  a call to the function \code{segment}.
}
\section{Objects from the Class}{
  Objects can be created by calls of the function
  \code{segment} or by calls of the form \code{new("segmentation", ...)}.
}

\section{Slots}{
  \describe{
    \item{\code{y}:}{A matrix with the data (the dependent variable(s)), see \code{\link{segment}}.} 
    \item{\code{x}:}{A numeric vector with the regressor variable.
      The length of this vector must be either the same as
      \code{nrow(y)}, or 0. The latter case is equivalent to
      \code{x=1:nrow(y)}.}
    \item{\code{flag}:}{An integer vector, whose length must be either the same as
      \code{nrow(y)}, or 0. This can be used to \emph{flag} certain
      probes for special treatment, for example by
      \code{\link{plotAlongChrom}}.}
    \item{\code{breakpoints}:}{List of segmentations. The element
      \code{breakpoints[[j]]} corresponds to a segmentation fit of
      \code{j} segments, i.e. with \code{j-1} breakpoints. It is a
      matrix with \code{(j-1)} rows and 1 or 3 columns. It always
      contains a column named \code{estimate} with the point estimates.
      Optionally, it may contain columns \code{lower} and \code{upper}
      with the confidence intervals. The point estimates are the row
      indices in \code{y} where new segments start, for example:
      let \code{z=breakpoints[[j]]}, then the first segment
      is from row \code{1} to \code{z[1, "estimate"]-1},
      the second from row \code{z[1, "estimate"]} to
      \code{z[2, "estimate"]-1}, and so on.}
    \item{\code{logLik}:}{Numeric vector of the same length as
      \code{breakpoints}, containing the log-likelihood of the piecewise
      constant models under the data \code{y}.}
    \item{\code{hasConfint}:}{Logical vector of the same length as
      \code{breakpoints}. TRUE if the confidence interval estimates
      are present, i.e. if the matrix \code{breakpoints[[j]]} has
      columns \code{lower} and \code{upper}.}
    \item{\code{nrSegments}:}{A scalar integer, value must be either
      \code{NA} or between \code{1} and \code{length(breakpoints)}.
      Can be used to select one of the fits in \code{breakpoints} for
      special treatment, for example by
      \code{\link{plotAlongChrom}}.}
  }
}

\section{Methods}{
  \describe{
    \item{confint}{The method \code{confint(object, parm, level=0.95,
	het.reg=FALSE, het.err=FALSE, ...)} computes confidence
      intervals for the change point estimates of the
      segmentation. Typically, these were obtained from a previous call
      to the function \code{\link{segment}} that created the object.
      This is just a wrapper for the function
      \code{\link[strucchange]{confint.breakpointsfull}}
      from the \code{strucchange} package, which does all the hard
      computations.
      Parameters: \code{object} an object of class \code{segmentation},
      \code{parm} an integer vector, it determines for which of the segmentation fits
      confidence intervals are computed. See also \code{\link{segment}}.
      The other parameters are directly passed on to
      \code{\link[strucchange]{confint.breakpointsfull}}.
    }
    \item{logLik}{The method \code{logLik(object, penalty="none", ...)}
      returns the log-likelihoods of fitted models. Valid values for the argument
      \code{penalty} are \code{none}, \code{AIC} and \code{BIC}.}
    \item{plot}{The method \code{plot(x, y, xlim, xlab="x", ylab="y",
	bpcol="black", bplty=1, pch=16, ...)}
      provides a simple visualization of the result of a
      segmentation. Parameters: \code{x} an object of class \code{segmentation},
      \code{y} an integer between \code{1} and
      \code{length(x@breakpoints)}, selecting which of the fits
      contained in \code{x} to plot, \code{bpcol} and \code{bplty} color
      and line type of breakpoints. The plot shows the numeric data
      along with breakpoints and if available their confidence intervals.}
    \item{show}{summary.}
  }
}

%\references{ ~put references to the literature/web site here ~ }
\author{Wolfgang Huber \email{huber@ebi.ac.uk}}

\seealso{\code{\link{segment}}}
\keyword{classes}

\examples{
## generate random data with 5 segments:
y = unlist(lapply(c(0,3,0.5,1.5,5), function(m) rnorm(10, mean=m)))

seg = segment(y, maxseg=10, maxk=15)
seg = confint(seg, parm=c(3,4,5))

if(interactive())
  plot(seg, 5)

show(seg)
}

\name{segment}
\alias{segment}

\title{Fit a piecewise constant curve: segmentation by dynamic
  programming}

\description{
  The function fits a piecewise constant curve to one or multiple
  sequences of measurements,
  using a least squares cost function and an O(n) dynamic programming
  algorithm (see references).
}
\usage{
segment(y, maxseg, maxk)
}
\arguments{
  \item{y}{Numeric matrix. Rows correspond to the
      \code{x}-variable, columns to replicate measurements at the same
      value of \code{x}. Breakpoints are fitted along the \code{x}-axis.
      For example, the \code{x}-variable can be genomic coordinates or
      time. The segmentation will be along the rows of \code{y}.}
  \item{maxseg}{integer of length 1, maximum number of segments (= 1 + maximum
    number of change points).}
  \item{maxk}{integer of length 1, maximum length of a single segment.}
}
\details{The complexity of the algorithm is 
\code{length(x)*maxk} in memory and
\code{length(x)*maxk*maxseg} in time.}

\value{
  An object of class \code{\link[tilingArray:class-segmentation]{segmentation}}.
}

\author{W. Huber \email{huber@ebi.ac.uk}}

\references{
  [1] Transcript mapping with high-density oligonucleotide tiling
  arrays. Huber W, Toedling J, Steinmetz, L.
  Bioinformatics 22, 1963-1970 (2006).
  
  [2] A statistical approach for CGH microarray data analysis.
  Franck Picard, Stephane Robin, Marc Lavielle, Christian Vaisse,
  Gilles Celeux, Jean-Jacques Daudin.
  BMC Bioinformatics. 2005 Feb 11; 6:27.
}

\examples{
  x = rep( sin((0:4)/2*pi), each=3) + rnorm(3*5, sd=0.1)
  res = segment(x, maxseg=6, maxk=15)
}
\keyword{manip}

\name{PMindex}
\alias{PMindex}
\alias{BGindex}

\title{Find the index of the exact match (PM) or background probes from a probeAnno environment}
\description{Find the index of the exact match (PM) or background probes from a probeAnno environment}
\usage{
PMindex(probeAnno)
BGindex(probeAnno)
}
\arguments{
\item{probeAnno}{environment with probe annotations. See
    package \code{davidTiling} for an example (?probeAnno).}
}
\details{
  These functions extract the exact match probes (PM) or background
  probes (from intergenic regions outside of known annotations) indices from \code{probeAnno}.  
  These indices can be used to select the relevant rows of intensity
  data from the \code{ExpressionSet} object for plotting and normalization.
}

\value{Numeric vector of indices.}

\author{Matt Ritchie <ritchie@ebi.ac.uk>}

\examples{
## library(davidTiling)
## data(davidTiling)
## data(probeAnno)
## pmind <- PMindex(probeAnno)
## mmind <- MMindex(probeAnno)
## bgind <- BGindex(probeAnno)
## boxplot(as.data.frame(log2(exprs(davidTiling))[pmind,]), outline=FALSE)           
}
\keyword{manip}

\name{sampleStep}
\alias{sampleStep}
\title{Sampling of ascending numbers to ensure minimal spacing.}
\description{
  Given a vector of ascending numbers and a step width, sample the
  numbers such that the difference between consecutive numbers is greater
  than or equal to \code{step}.
}
\usage{
sampleStep(x, step)
}
\arguments{
  \item{x}{Numeric or integer vector.}
  \item{step}{Numeric scalar.}
}
\details{The simple algorithm works greedily from \code{x[1]} to
  \code{x[length(x)]}. First, \code{x[1]} is selected. Then, if \code{x[i]}
  is selected, all numbers \code{x[j]} with \code{j>i} and
  \code{x[j]-x[i]<step} are dropped. Then, \code{i} is set to the
  smallest j with \code{x[j]-x[i]>=step}.}
\value{
  A logical vector of the same length as \code{x}, representing the
  selected subsample.
}

\author{W. Huber <huber@ebi.ac.uk>}

\examples{
 x   = sort(as.integer(runif(20)*100))
 sel = sampleStep(x, step=10)
 x
 x[sel]

}
\keyword{manip}

\name{plotSegmentationDots}
\alias{plotSegmentationDots}
\title{Plot points for a region along a chromosome}
\keyword{hplot}
\description{Plot points for a region along a chromosome}

\usage{
plotSegmentationDots(dat, xlim, ylim, ylab, threshold=NA, 
                     chr=1, strand="+", vpr, colors, main, 
                     pointSize=unit(0.6, "mm"), showConfidenceIntervals=TRUE, 
                     sepPlots=FALSE, cexAxisLabel=1, cexAxis=1,...)
}

\arguments{
  \item{dat}{list containing data to be plotted (see \emph{Details} section below for particulars).}
  \item{xlim}{integer vector of length 2 with start and end coordinates (in bases) for plotting.}
  \item{ylim}{numeric vector containing the y limits of the plot.}
  \item{ylab}{character scalar (if \code{sepPlots=FALSE}) or vector containing y-axis label(s).}
  \item{threshold}{numeric scalar indicating the threshold of expression (default value is NA, for 
   no threshold.  If a value is supplied, it is subtracted from the intensity measures in \code{dat$y}.}
  \item{chr}{integer of length 1 indicating the chromosome to be plot (defaults to 1).}
  \item{strand}{character scalar which should be set to either \code{+} or \code{-} to 
    indicate which strand of DNA to plot the intensity values from (defaults to "+").}
  \item{vpr}{which viewport to plot the figure in.  If this function is called directly 
   by the user this argument should be left missing.}
  \item{colors}{named character vector, optional. If missing, 
    a default color scheme is used:
    \code{c("+"="#00441b", "-"="#081d58", "duplicated"="grey", "cp"="#101010", 
   "highlight"="red", "threshold"="grey")}, 
   where the first three elements refer to the colors of data points and the 
   last three to the colors of lines in the plot.}
  \item{main}{character vector specifying plot title.}
  \item{pointSize}{an object of class unit which specifies the size of each point.  Default value is \code{unit(0.6, "mm")}.}
  \item{showConfidenceIntervals}{logical scalar indicating whether confidence intervals for each change-point are to be plotted (only available once segmentation has occurred).}
  \item{sepPlots}{logical scalar indicating whether the intensities are plotted separately for each array (if \code{dat$y} has multiple columns).  Defaults to FALSE, in which case the average intensity for each probe is plotted.  When TRUE, up to 3 arrays can be plotted separately (more than 3 gets crowded).}
  \item{cexAxisLabel}{numeric scalar specifying the magnification to be used for the y-axis label relative to the current test size.}
  \item{cexAxis}{numeric scalar specifying the magnification to be used for the y-axis annotation relative to the current text size.}
  \item{...}{additional arguments.}
}

\details{
  This function is called by \code{plotAlongChrom} when the argument \code{what} is set to \code{dots}.  Although this function can be called directly by the user, this is not recommended.

The \code{dat} list contains the following items:
items \code{x}: x-coordinates (in bases) along chromosome, 
\enumerate{
    \item \code{y}: intensity matrix of probes along chromosome,
    \item \code{flag}: indicates probe uniqueness in the genome.  Possibilities are 3: multiple perfect matches, 2: has no PM but one or more near-matches, 1: has exactly one PM and some near-matches in the genome, 0: has exactly one PM and no near-matches.
    \item \code{extras}: (optional) matrix of additional values (such as test-statistics/p-values) to be plotted.
    }
}
      
\author{Wolfgang Huber <huber@ebi.ac.uk>}

\name{plotAlongChromLegend}
\alias{plotAlongChromLegend}
\title{Plot a legend for genomic features}
\keyword{hplot}
\description{Plot a legend for genomic features}

\usage{
plotAlongChromLegend(vpr, nr=2, 
    featureColorScheme=1, 
    featureExclude=c("chromosome", "nucleotide_match", "insertion"),
    mainLegend, cexLegend=0.35, cexMain=1)
}

\arguments{
  \item{vpr}{vector specifying where to place the legend in figure (set up by using the 
   \code{viewport} function from the grid package.  When this function is called directly 
   by the user this argument should be left missing.}
  \item{nr}{numeric scalar, specifying the number of rows to plot legend over 
   (default value is 2).}
  \item{featureColorScheme}{numeric scalar, used to select a color scheme for the 
   boxes representing genomic features such as coding sequences, ncRNAs etc. 
   Currently the only value supported is 1.}
  \item{featureExclude}{character vector of names of feature types (in
   \code{gff}) that should not be plotted. Default is \code{"chromosome"}, \code{"nucleotide_match"} and 
   \code{"insertion"}.  Additional possible candidates include: \code{"ARS"}, 
   \code{"repeat\_region"}, \code{"repeat\_family"} and 
   \code{"nc\_primary\_transcript"}.}
  \item{mainLegend}{character vector specifying legend title.}
  \item{cexLegend}{numeric scalar specifying the magnification to be used for the legend 
   text relative to the current text size.}
  \item{cexMain}{numeric scalar specifying the magnification to be used for the legend 
   title relative to the current text size.}
}

\details{
  This function is usually called by \code{plotAlongChrom} when \code{doLegend} is TRUE.  It can also be called directly by the user to produce a separate legend.  

The following features are included in the legend (unless excluded using the \code{featuredExclude} option): \code{"chromosome"}, \code{"nucleotide_match"}, \code{"pseudogene"}, \code{"uORF"}, \code{"nc_primary_transcript"}, \code{"region"}, \code{"repeat_family"}, \code{"repeat_region"}, \code{"transposable_element"}, \code{"transposable_element_gene"}, \code{"ARS"}, \code{"centromere"}, \code{"telomere"}, \code{"insertion"}, \code{"CDS"}, \code{"CDS_dubious"}, \code{"ncRNA"}, \code{"tRNA"}, \code{"snRNA"}, \code{"rRNA"}, \code{"snoRNA"}, \code{"binding_site"} and \code{"TF_binding_site"}.}

\author{Wolfgang Huber <huber@ebi.ac.uk>}
\examples{## plotAlongChromLegend(mainLegend="Legend")}

\name{breakpointsPretend}
\alias{residuals.breakpointsPretend}
\alias{breakpoints.breakpointsPretend}
  
\title{Accessor methods for breakpointsPretend objects - not to be called
  by the user.}

\description{
  Accessor methods for breakpointsPretend objects - not to be called
  by the user.

  These functions are used in the interface between the
  \code{segmentation} class and the
  \code{\link[strucchange:confint.breakpointsfull]{confint.breakpointsfull}}
  method of the strucchange package. This method calls
  \code{breakpoints} and \code{residuals} methods for its first
  argument, and since we pass an argument of S3 class
  \code{breakpointsPretend}, we can avoid the overhead of the
  corresponding methods for \code{breakpointsfull} objects.
  These functions are of no interest to the user.
}

\usage{
\S3method{residuals}{breakpointsPretend}(object, breaks, ...)
breakpoints.breakpointsPretend(obj, breaks, ...) 
}

\arguments{
  \item{object}{a breakpointsPretend object.}
  \item{obj}{a breakpointsPretend object.}
  \item{breaks}{dummy argument, is ignored.}
  \item{...}{futher arguments.}
}

\value{residuals and breakpoints.}

\author{W. Huber \email{huber@ebi.ac.uk}}

\keyword{manip}

\name{gffSub}
\alias{gffSub}
\title{Example of a genomic feature object }
\description{Example of a genomic feature object}
\usage{
 data(gffSub)
}
\details{
  gffSub is a data frame that contains the features from 35000bp - 50000bp in yeast chromosome one.    	  
}

\author{Zhenyu Xu <zhenyu@ebi.ac.uk>}

\examples{
  data(segnf)
  data(gffSub)
  nmLabel = colnames(segnf$"1.+"@y)
  plotAlongChrom(segnf,chr=1, coord=c(35000,50000),what="heatmap", 
  		gff=gffSub,rowNamesHeatmap=nmLabel)
}
\keyword{data}

\name{plotAlongChrom}
\alias{plotAlongChrom}
\title{Plot signals and segmentation for a region of a chromosome}
\keyword{hplot}
\description{Plot signals and segmentation for a region of a chromosome}

\usage{
plotAlongChrom(segObj, y, probeAnno, gff,
    isDirectHybe=FALSE, 
    what = c("dots"), ## "heatmap"
    chr, coord, highlight,
    colors, doLegend=FALSE,
    featureExclude=c("chromosome", "nucleotide_match", "insertion"),
    featureColorScheme=1, extras, 
    rowNamesHeatmap, rowNamesExtras, ylab, ylabExtras, main, 
    colHeatmap=colorRamp(brewer.pal(9, "YlGnBu")), 
    colExtras=colorRamp(brewer.pal(9, "Reds")), 
    sepPlots=FALSE, reOrder=TRUE, ...)
}

\arguments{
  \item{segObj}{Either an environment or an object of S4 class
    \code{segmentation}.
    See \emph{Details}.}
  \item{y}{a numeric vector or matrix containing the signal to be
    plotted. See \emph{Details}.}
  \item{probeAnno}{environment with probe annotations. See
    \emph{Details}, and package
    \code{davidTiling} for an example.}
  \item{gff}{data frame with genome annotation from the GFF file.}
  \item{isDirectHybe}{logical scalar: if TRUE, the mapping of probes to genomic 
   strands is reversed with respect to the default. This is appropriate for data 
   from a direct RNA hybridization that used no reverse transcription.} 
  \item{what}{character scalar indicating which signal visualization to plot.  Can be
    either \code{dots} to plot each probe intensity with a point, or \code{heatmap} to produce a colorscale representation of the intesities.}  
  \item{chr}{integer of length 1 indicating the chromosome number to plot.}
  \item{coord}{integer vector of length 2 containing the start and end coordinates (in
    bases) for the plot.}
  \item{highlight}{(optional) list with two elements: a single numeric value
    \code{coord} and a character \code{strand}. If present, this
    position is marked by a vertical red bar on the coordinate axis.  The color can be changed using the \code{colors} argument below.}
  \item{colors}{(optional) named character vector. If missing, 
    a default color scheme is used:
    \code{c("+"="#00441b", "-"="#081d58", "duplicated"="grey", "cp"="#101010", 
   "highlight"="red", "threshold"="grey")}, 
   where the first three elements refer to the colors of data points and the 
   last three to the colors of lines in the plot.}
  \item{doLegend}{logical: should the plot contain a legend?} 
  \item{featureExclude}{character vector of names of feature types (in
    \code{gff}) that should not be plotted. Default is \code{"chromosome"}, 
    \code{"nucleotide_match"} and \code{"insertion"}.  Additional possibilities 
    include: \code{"ARS"}, \code{"repeat\_region"}, 
    \code{"repeat\_family"} and \code{"nc\_primary\_transcript"}.}
  \item{featureColorScheme}{numeric scalar, used to select a color scheme for the 
   boxes representing genomic features such as coding sequences, ncRNAs etc. 
   Currently the only value supported is 1 (see \code{plotAlongChromLegend} or \code{plotFeatures} for further information).}
  \item{extras}{a matrix containing additional values to be plotted along the 
    chromosome in a separate panel (such as p-values).  This option is only 
    available when \code{y} is specified.  These values should be on the scale [0,1].}
  \item{rowNamesHeatmap}{character vector of row names for the main heatmap.}
  \item{rowNamesExtras}{character vector of row names for the extra heatmap.}
  \item{ylab}{character label for y-axis of main plot.}
  \item{ylabExtras}{character label for y-axis on \code{extras} panel (if specified).}
  \item{main}{character: plot title.}
  \item{colHeatmap}{function describing color scheme for the main heatmap plot (defaults to
    \code{YlGnBu} from RColorBrewer package).}
  \item{colExtras}{function describing color scheme for the extra heatmap plot (if specified)   
    (defaults to \code{Reds} from RColorBrewer package).}
  \item{sepPlots}{logical scalar.  If TRUE, each column of intensities in \code{segObj} or 
    \code{y} is plotted separately (maximum of 3) in the same figure. When FALSE, the average 
    is plotted.  This argument is only used when \code{what} is set to \code{dots}.}
  \item{reOrder}{logical scalar (only used when sepPlots is TRUE). If TRUE, the first 
    column of intensities is printed at the bottom of each plot, and the subsequent columns 
    are plotted above.  If FALSE, the first appears at the top, and the subsequent columns 
    are plotted below.}
  \item{...}{further arguments that can be passed to the
    functions that implement the \code{what} option above (see
    \code{plotSegmentationDots} and 
    \code{plotSegmentationHeatmap}) or \code{gff} plotting (see \code{plotFeatures} and \code{plotAlongChromLegend}).}
}

\details{
  \emph{Intensities}: There are two alternative, mutually exclusive
  ways of providing the intensities that are to be plotted to this function.
  \enumerate{
    \item Via the parameters \code{y} and \code{probeAnno}. In this case,
    \code{y} is a matrix of intensities, whose rows correspond to probes
    on the array, and its columns to different conditions, time points, etc.
    It is also acceptable that \code{y} is provided as a vector, in
    which case it is converted to an \code{nrow(y) x 1} matrix.
    \code{probeAnno} is an
    environment whose elements correspond to target sequences (e.g.
    chromosome strands) and that contain integer vectors of length
    \code{nrow(y)} with information about the probes: start and end positions of
    their alignment to the target sequence, their row indices in
    \code{y}, the type of alignment (is it perfect? is is unique?).
    For example,
    the start positions and indices of probes for the + strand of
    chromosome 1 would be described by environment elements
    \code{"1.+.start"} and \code{"1.+.index"}.
    
    \item Via the parameter \code{segObj}.
  }

  \emph{segObj}: This can be either an object of S4 class
  \code{segmentation} or an environment that by convention contains a
  certain set of objects.
  Future work on this package
  will focus on the S4 class \code{segmentation}. The \code{environment}
  option is provided for backward compatibility.
  
  \emph{Explanation of the environment}: the intended workflow is as follows:
  Use the script \code{segment.R} (in the \code{inst/scripts} directory of this
  package) to generate segmentations.
  This can be run in parallel on several processors, separately for each
  chromosome and strand. The results of this are stored in files of the
  name \code{1.+.rda}, \code{1.-.rda}, \code{2.+.rda}, and so forth,
  typically within a dedicated directory.
  Then use the script \code{readSegments.R} to collect the
  \code{R} objects in these \code{.rda} files into the environment.
  It contains three types of data:
  \itemize{
    \item microarray intensities in along-chromosome order.
    \item the segmentation objects (output of findSegments).
    \item a dataframe named \code{segScore} with segment scores; it can
    be missing iff \code{nrBasesPerSeg} is present,
    \item a numeric scalar names \code{theThreshold}, which is used to 
    draw a horizontal "threshold" line in the plot.
  }

  \emph{\dots and the different signal visualization methods (\code{what} option)}:
  If \code{what=="dots"}, the argument \code{showConfidenceIntervals}
  can  be a logical scalar to choose whether vertical dashed lines are
  drawn for the confidence interval. In any case, these are only drawn
  if they are present in the \code{segmentation} object in \code{segObj}.
} 
  

\author{Wolfgang Huber <huber@ebi.ac.uk>}
\examples{
  ## 1. see viewSegmentation.R script in the inst/scripts directory
  ## 2. (newer): segmentation.Rnw
  ## 3. (newer): see the plotALongChrom vignette
  data(segnf)
  data(gffSub)
  nmLabel = colnames(segnf$"1.+"@y)
  plotAlongChrom(segnf,chr=1,coord=c(35000,50000),
  			gff=gffSub,rowNamesHeatmap=nmLabel) ##the dots
  plotAlongChrom(segnf,chr=1,coord=c(35000,50000),what="heatmap", 
  			gff=gffSub,rowNamesHeatmap=nmLabel) ##the heatmap
  			
  plotAlongChrom(segnf,chr=1,coord=c(35000,50000),gff=gffSub,
  			showConfidenceIntervals=FALSE) ##do not show the segment confidence interval	
   }

\name{plotPenLL}
\alias{plotPenLL}

\title{
  Plot the log-likelihood and penalized
  log-likelihoods (AIC, BIC)}
\description{
  Plot the log-likelihood and two versions of penalized
  log-likelihoods (AIC, BIC) for a segmentation object.
}
  
\usage{
plotPenLL(seg, extrabar=numeric(0), type="b", lty=1, pch=16, lwd=2, ...)
}

\arguments{  
  \item{seg}{A \code{\linkS4class{segmentation}} object.}
  \item{extrabar}{In addition to the location of maximmal BIC,
    vertical bars are drawn at these x-positions as well.}
  \item{type, pch, lty, lwd, ...}{Get passed on to \code{\link{matplot}}.}
}

\details{
  This function is used in the vignette:
  \emph{How to use the segment function to fit a piecewise constant curve.}
}

\value{
  The function is called for its side effect, which is creating a plot
  in the current graphics device.}

\author{Wolfgang Huber <huber@ebi.ac.uk>}

\examples{
  x = rep( sin((0:4)/2*pi), each=3) + rnorm(3*5, sd=0.1)
  res = segment(x, maxseg=8, maxk=15)
  plotPenLL(res)
}
\keyword{manip}

\name{plotSegmentationHeatmap}
\alias{plotSegmentationHeatmap}
\title{Plot a heatmap diagram for a region along a chromosome}
\keyword{hplot}
\description{Plot a heatmap diagram for a region along a chromosome}

\usage{
plotSegmentationHeatmap(dat, xlim, ylab, rowNames, 
                        chr=1, strand="+", vpr, colors, 		
                        colHeatmap=colorRamp(brewer.pal(9, "YlGnBu")), 
                        showConfidenceIntervals=TRUE,
                        just=c("left","centre"),
                        main,makeRasterImage = TRUE, ...)
}

\arguments{
  \item{dat}{list containing data to be plotted (see \emph{Details} section below for particulars).}
  \item{xlim}{integer vector of length 2 with start and end coordinates (in bases) for plotting.}
  \item{ylab}{character scalar specifying y-axis label.}
  \item{rowNames}{character vector specifying a name for each row in the heatmap plot.}
  \item{chr}{integer of length 1 indicating the chromosome to plot (defaults to 1).}
  \item{strand}{character scalar which should be set to either \code{+} or \code{-} to 
    indicate which strand of DNA to plot the intensity values from (defaults to "+").}
  \item{vpr}{which viewport to plot the figure in.  If this function is called directly 
   by the user this argument should be left missing.}
  \item{colors}{named character vector, optional. If missing, 
    a default color scheme is used:
    \code{c("+"="#00441b", "-"="#081d58", "duplicated"="grey", "cp"="#101010", 
   "highlight"="red", "threshold"="grey")}, 
   where the first three elements refer to colors of data points and the 
   last three to those of lines in the plot.}
  \item{colHeatmap}{function describing color scheme for the heatmap plot (defaults to
    \code{YlGnBu} from RColorBrewer package).}  
  \item{showConfidenceIntervals}{logical scalar indicating whether
    confidence intervals for each change-point are to be plotted (only
    available once segmentation has occurred).}
  \item{just}{character vector specifying the justification of the
    supplied values to the given coordinates; setting the first entry to
    "left" indicates that the supplied x-coordinates are the start
    positions of the probes, change this to "centre" if the
    x-coordinates are the probe middle positions. Usually the second
    entry should be "centre" (see \code{\link[grid]{grid.rect}})}
  \item{main}{character vector specifying plot title.}
  \item{makeRasterImage}{logical scalar indicating whether to plot the heatmap image
  	by the grid.raster (see \code{\link[grid]{grid.raster}}) or 
  	the grid.rect (see \code{\link[grid]{grid.rect}}) function in grid package.The default is to 
  	generate raster image, as it can be displayed much faster with a relatively smaller file size.}
  \item{...}{additional arguments.}
}

\details{
  This function is called by \code{plotAlongChrom} if the argument
  \code{what} is set to \code{heatmap}.
  Although this function can be called directly by the user, this is not recommended.
  The \code{dat} list contains the following items:
  \describe{
    \item{\code{x}}{x-coordinates (in bases) along chromosome}
    \item{\code{y}}{intensity matrix of probes along chromosome}
    \item{\code{flag}}{indicates probe uniqueness in the genome.  Possibilities are 3: multiple perfect matches, 2: has no PM but one or more near-matches, 1: has exactly one PM and some near-matches in the genome, 0: has exactly one PM and no near-matches.}
    \item{\code{extras}}{(optional) matrix of additional values (such as test-statistics/p-values) to be plotted}
  }
}
\examples{
  data(segnf)
  data(gffSub)
  nmLabel = colnames(segnf$"1.+"@y)
  plotAlongChrom(segnf,chr=1,coord=c(35000,50000),what="heatmap", 
  		gff=gffSub,rowNamesHeatmap=nmLabel) ##using raster image
}
\author{Wolfgang Huber <huber@ebi.ac.uk>}

\name{posMin}
\alias{posMin}
\title{Find the smallest positive number in a vector}
\description{Find the smallest positive number in a vector}
\usage{
posMin(x, ...)
}
\arguments{
  \item{x}{Numeric vector.}
  \item{...}{Further arguments that get passed on to \code{min}.}
}
\details{
  This is a rather trivial convenience function.
}

\value{Numeric of length 1.
}

\author{W. Huber <huber@ebi.ac.uk>}

\examples{
  x = runif(5)
  posMin(x-0.5)
  posMin(x-2)
}
\keyword{manip}

\name{comparisonPlot}
\alias{comparisonPlot}

\title{
  Plot a vertical layout of panels for the comparison of different
  along-chromosome profiles.
}
\description{
  This function is used for Figure 5 in the David et al. (PNAS 2006)
  paper and in the Huber et al. methods paper.
}
\usage{
comparisonPlot(x, y, xscale=range(x), yscale, anno, ticks, pch=20, cex=1, bgcol="#f2f2f2")
}
\arguments{
  \item{x}{numeric vector.}
  \item{y}{list of numeric vector, each of same length as \code{x}.}
  \item{xscale}{numeric vector of length 2.}
  \item{yscale}{matrix with 2 rows and columns corresponding to the
    elements of \code{x}.}
  \item{anno}{dataframe with columns \code{start}, \code{end}, and
    \code{name}, each row corresponds to one gene CDS to be plotted at the bottom.}
  \item{ticks}{numeric vector, where to plot the ticks.}
  \item{pch}{A numeric or character vector indicating what sort of
    plotting symbol to use, see \code{\link[grid]{grid.points}}.}
  \item{cex}{Multiplier applied to fontsize, see \code{\link[grid]{gpar}}.}
  \item{bgcol}{Color to use as background for some of the plot panels.}
}

\value{
  Function is called for its side-effect.
}

\author{W. Huber \email{huber@ebi.ac.uk}}

\references{...}

\examples{
  ##
}
\keyword{manip}
